-- written by Gizmo
----------------------------------------------------------------------
-- If you like Project Phoenix and want to help support the project
-- you could send any donation amount to jessebutler1975@gmail.com at
-- paypal.com
--
-- Thank you for using my product, 
-- I hope you enjoy it as much as I do
----------------------------------------------------------------------
require 'default:globals.dynamic_window.hud'

local guardProtectionStrs = {
		["Area-Oasis"] = "[E1BB00]Protected[-]",
		["ForestOutpost"] = "[E1BB00]Protected[-]",
		["GuardTower"] = "[E1BB00]Protected[-]",
		["Guard"] = "[00FF00]Protected[-]",
		["InstaKill"] = "[00FF00]Protected[-]"
	}

function UpdateRegionStatus(playerObj,areaName,curProtection)		
	areaName = areaName or GetRegionalName(playerObj:GetLoc())
	curProtection = curProtection or playerObj:GetObjVar("GuardProtection") or ""

	local protectionStr = guardProtectionStrs[curProtection] or "[FF0000]Unprotected[-]"	

	local dynWindow = DynamicWindow("regionstatus","",0,0,-196,190,"Transparent","TopRight")
	dynWindow:AddLabel(100,0,areaName,0,0,20,"center",false,true,"SpectralSC-SemiBold")
	dynWindow:AddLabel(100,18,protectionStr,0,0,16,"center",false,true,"SpectralSC-SemiBold")

	-- not the best place to put the god button but it works
	if(IsImmortal(playerObj)) then
		dynWindow:AddButton(157,-77,"","",22,21,"","ToggleGodWindow",false,"God")
	end

	--CUSTOM BUTTONS BEGIN
	dynWindow:AddButton(11,-77,"","",22,21,"[FF7700]Quest Log\n[FFFFFF]Click this to open your [FF7700]Quest Log[FFFFFF].\n\nYou can use this to track quests\nthat you acquire along your travels in the realm of [FF7700]Aria[FFFFFF].","ToggleQuestLog",false,"Invisible")		
	dynWindow:AddImage(9,-79,"Skill_AnimalLore",24,24,"Sliced","FFFF00")
	dynWindow:AddImage(10,-78,"Skill_AnimalLore",22,22,"Sliced","353535")
	dynWindow:AddLabel(21,-74,"[FFFF00]Q",0,0,18,"center",false,true,"SpectralSC-SemiBold")

	--dynWindow:AddButton(21,-142,"","",22,21,"[FF7700]Web Browser\n[FFFFFF]Click this to open your\n[FF7700]Web Browser[FFFFFF]. You can use this\nfor all kinds of fun stuff.\nEnjoy your stay in [FF7700]Aria[FFFFFF].","ToggleWebBrowser",false,"Invisible")		
	--dynWindow:AddImage(18,-145,"Skill_Manifestation",25,25,"Sliced","151515")
	--dynWindow:AddImage(21,-142,"Skill_Manifestation",22,22,"Sliced","FFFFFF")
	

	dynWindow:AddButton(8,-102,"","",22,21,"[FF7700]Faction Window\n[FFFFFF]Click this to open your\n[FF7700]Faction Window[FFFFFF]. You can use this\nto view your faction standings.","ToggleFactionWindow",false,"Invisible")		
	dynWindow:AddImage(6,-104,"Skill_Channeling",24,24,"Sliced","FFFF00")
	dynWindow:AddImage(7,-103,"Skill_Channeling",22,22,"Sliced","353535")
	dynWindow:AddLabel(18,-99,"[FFFF00]F",0,0,18,"center",false,true,"SpectralSC-SemiBold")
	--CUSTOM BUTTONS END

	playerObj:OpenDynamicWindow(dynWindow)
end


