-- written by Gizmo
----------------------------------------------------------------------
-- If you like Project Phoenix and want to help support the project
-- you could send any donation amount to jessebutler1975@gmail.com at
-- paypal.com
--
-- Thank you for using my product, 
-- I hope you enjoy it as much as I do
----------------------------------------------------------------------
require 'default:globals.helpers.pets'
--================================================================
--                 	   PROJECT PHOENIX OVERRIDE
--================================================================
function SetCreatureAsPet(creature, master)
    Verbose("Pet", "SetCreatureAsPet", creature, master)
	if ( master == nil or creature == nil or not master:IsValid() or not creature:IsValid() or creature:IsPlayer() ) then return false end
	local myOldTeam = creature:GetObjVar("MobileTeamType")
	if(myOldTeam ~= nil) then
		creature:DelObjVar("MobileTeamType")
		creature:SetObjVar("OldMobileTeamType", myOldTeam)
	end
	--SPAWNER EDIT
	if(creature:HasObjVar("parentSpawner")) then
		GameObj(creature:GetObjVar("parentSpawner")):SendMessage("mobHasDied", creature)
	end
	--END SPAWNER EDIT
	--QUEST EDIT
	CustomQuests.Helpers.CheckQuestObjectives(master, creature)
	--END QUEST EDIT
	creature:SetObjVar("LivingKarma", GetKarma(creature))
	local nameStr = StripColorFromString(creature:GetName())
	creature:SetObjVar("LivingName", nameStr)
	UpdatePetCommandName(creature, nameStr)
	creature:AddModule("pet_controller")
	creature:SendMessage("SetPetOwner", master)
	creature:SetObjVar("MobileTeamType","Villagers")
	creature:SetMobileType("Friendly")
	creature:SetObjVar("NoReset",true)
	if(creature:HasModule("decay")) then
		creature:DelModule("decay")
	end
	creature:SetObjVar("HasSkillCap",true)
	creature:SendMessage("EndCombatMessage")
	creature:PlayObjectSound("Pain")
	master:SystemMessage("You have tamed "..StripColorFromString(nameStr),"info")
	return true
end
--================================================================
-- 					END PROJECT PHOENIX OVERRIDE
--================================================================


