-- written by Gizmo
----------------------------------------------------------------------
-- If you like Project Phoenix and want to help support the project
-- you could send any donation amount to jessebutler1975@gmail.com at
-- paypal.com
--
-- Thank you for using my product, 
-- I hope you enjoy it as much as I do
----------------------------------------------------------------------
require 'loot_magic_item_generation'

function getIf(mBool, v1, v2)
    if mBool then 
        return v1
    else
        return v2
    end
end

------------------------------------------------------------------
-- covers text colors for the magic item property list
-- @PropertyColor - this is for the property name like Accuracy
-- @PropertyColorValue - this is for the numeric value color
------------------------------------------------------------------
LootTable.TextColors =
{
	PropertyColor = "[CCCC66]",
	PropertyValueColor ="[6699CC]",
	PropertyValueColorNegative="[CC3333]",
}
------------------------------------------------------------------
-- this is a blank template to stamp on a item it has all the
-- current variables needed.
------------------------------------------------------------------
LootTable.PropertyTable = {
	AccuracyPlus 		= 0,
	AccuracyTimes		= 0,
	AgilityPlus 		= 0,
	AgilityTimes		= 0,
	AttackPlus 			= 0,
	AttackTimes			= 0,	
	PowerPlus			= 0,
	PowerTimes			= 0,	
	ForcePlus			= 0,
	ForceTimes			= 0,	
	ConstitutionPlus	= 0,
	ConstitutionTimes 	= 0,	
	CritChancePlus		= 0,
	CritChanceTimes		= 0,	
	DefensePlus			= 0,
	DefenseTimes		= 0,	
	EvasionPlus			= 0,
	EvasionTimes		= 0,	
	IntelligencePlus	= 0,
	IntelligenceTimes	= 0,	
	StrengthPlus		= 0,
	StrengthTimes		= 0,	
	WillPlus			= 0,
	WillTimes			= 0,	
	WisdomPlus			= 0,
	WisdomTimes			= 0,	
	MaxHealthPlus		= 0,
	MaxHealthTimes		= 0,	
	MaxManaPlus			= 0,
	MaxManaTimes        = 0,	
	MaxStaminaPlus		= 0,
	MaxStaminaTimes		= 0,	
	MaxVitalityPlus		= 0,
	MaxVitalityTimes	= 0,	
	HealthRegenPlus		= 0,
	HealthRegenTimes	= 0,	
	ManaRegenPlus		= 0,
	ManaRegenTimes		= 0,	
	StaminaRegenPlus	= 0,
	StaminaRegenTimes	= 0,	
	VitalityRegenPlus	= 0,
	VitalityRegenTimes	= 0,	
	MoveSpeedPlus		= 0,
	MoveSpeedTimes 		= 0,		
}
------------------------------------------------------------------
-- this is the string name value of the property
------------------------------------------------------------------
LootTable.PropertyBonusStrings = {
	AccuracyPlus 		= "Accuracy",
	AccuracyTimes	 	= "Accuracy",
	AgilityPlus 		= "Agility",
	AgilityTimes		= "Agility",
	AttackPlus 			= "Attack",
	AttackTimes			= "Attack",	
	PowerPlus			= "Power",
	PowerTimes			= "Power",	
	ForcePlus			= "Force",	
	ForceTimes			= "Force",
	ConstitutionPlus	= "Constitution",
	ConstitutionTimes	= "Constitution",	
	CritChancePlus		= "Critical",
	CritChanceTimes		= "Critical",	
	DefensePlus			= "Defense",
	DefenseTimes		= "Defense",	
	EvasionPlus			= "Evasion",
	EvasionTimes		= "Evasion",	
	IntelligencePlus	= "Intelligence",
	IntelligenceTimes	= "Intelligence",	
	StrengthPlus		= "Strength",
	StrengthTimes		= "Strength",	
	WillPlus			= "Will",
	WillTimes			= "Will",	
	WisdomPlus			= "Wisdom",
	WisdomTimes			= "Wisdom",	
	MaxHealthPlus		= "Health",
	MaxHealthTimes		= "Health",	
	MaxManaPlus			= "Mana",
	MaxManaTimes		= "Mana",	
	MaxStaminaPlus		= "Stamina",
	MaxStaminaTimes		= "Stamina",	
	MaxVitalityPlus		= "Vitality",
	MaxVitalityTimes	= "Vitality",	
	HealthRegenPlus		= "Health Regen",
	HealthRegenTimes	= "Health Regen",	
	ManaRegenPlus		= "Mana Regen",	
	ManaRegenTimes		= "Mana Regen",
	StaminaRegenPlus	= "Stamina Regen",
	StaminaRegenTimes	= "Stamina Regen",	
	VitalityRegenPlus	= "Vitality Regen",	
	VitalityRegenTimes	= "Vitality Regen",
	MoveSpeedPlus		= "Movement Speed",
	MoveSpeedTimes		= "Movement Speed",		
}
------------------------------------------------------------------
--					 ARMOR TABLES BY SUIT TYPE
------------------------------------------------------------------
LootTable.Equipment.Armor.Assassin = 
{
	Chest="armor_assassin_chest",
	Legs="armor_assassin_leggings",
	Head="armor_assassin_helm",
}
LootTable.Equipment.Armor.Bone = 
{
	Chest="armor_bone_chest",
	Legs="armor_bone_leggings",
	Head="armor_bone_helm",
}
LootTable.Equipment.Armor.Brigandine = 
{
	Chest="armor_brigandine_tunic",
	Legs="armor_brigandine_leggings",
	Head="armor_brigandine_helm",
}
LootTable.Equipment.Armor.Chain = 
{
	Chest="armor_chain_tunic",
	Legs="armor_chain_leggings",
	Head="armor_chain_helm",
}
LootTable.Equipment.Armor.FullPlate = 
{
	Chest="armor_fullplate_tunic",
	Legs="armor_fullplate_leggings",
	Head="armor_fullplate_helm",
}
LootTable.Equipment.Armor.Hardened = 
{
	Chest="armor_hardened_chest",
	Legs="armor_hardened_leggings",
	Head="armor_hardened_helm",
}
LootTable.Equipment.Armor.Leather = 
{
	Chest="armor_leather_chest",
	Legs="armor_leather_leggings",
	Head="armor_leather_helm",
}
LootTable.Equipment.Armor.Linen = 
{
	Chest="robe_linen_tunic",
	Legs="robe_linen_leggings",
	Head="robe_linen_helm",
}
LootTable.Equipment.Armor.Padded = 
{
	Chest="robe_padded_tunic",
	Legs="robe_padded_leggings",
	Head="robe_padded_helm",
}
LootTable.Equipment.Armor.Plate = 
{
	Chest="armor_plate_tunic",
	Legs="armor_plate_leggings",
	Head="armor_plate_helm",
}
LootTable.Equipment.Armor.Scale = 
{
	Chest="armor_scale_tunic",
	Legs="armor_scale_leggings",
	Head="armor_scale_helm",
}
------------------------------------------------------------------
--							SHIELD TABLE
------------------------------------------------------------------
LootTable.Equipment.Armor.Shields = 
{
	Buckler="shield_buckler",
	Curved="shield_curvedshield",
	Kite="shield_kite",
	Small="shield_smallshield",
}
------------------------------------------------------------------
--							WEAPON TABLES
------------------------------------------------------------------
LootTable.Equipment.Weapons.Slashing1H = 
{
	Broadsword="weapon_broadsword",
	Katana="weapon_katana",
	Longsword="weapon_longsword",
	Saber="weapon_saber",
}
LootTable.Equipment.Weapons.Slashing2H = 
{
	GreatAxe="weapon_greataxe",
	LargeAxe="weapon_largeaxe",
}
LootTable.Equipment.Weapons.Bashing1H = 
{
	Mace="weapon_mace",
	Hammer="weapon_hammer",
	Maul="weapon_maul",
	WarMace="weapon_war_mace",
}
LootTable.Equipment.Weapons.Bashing2H = 
{
	QuarterStaff="weapon_quarterstaff",
	WarHammer="weapon_warhammer",
}
LootTable.Equipment.Weapons.Piercing1H = 
{
	Dagger="weapon_dagger",
	Kryss="weapon_kryss",
	Poniard="weapon_poniard",
	BoneDagger="weapon_bone_dagger",
}
LootTable.Equipment.Weapons.Archery = 
{
	BoneBow="weapon_bonebow",
	LongBow="weapon_longbow",
	SavageBow="weapon_savagebow",
	ShortBow="weapon_shortbow",
	WarBow="weapon_warbow",
}
LootTable.Equipment.Weapons.Lancing = 
{
	Halberd="weapon_halberd",
	Spear="weapon_spear",
	Vouge="weapon_vouge",
	Warfork="weapon_warfork",
}
LootTable.Equipment.Weapons.Staves =
{
	Staff="staff",
}
------------------------------------------------------------------
--							OFFHAND TABLE
------------------------------------------------------------------
LootTable.Equipment.Weapons.Offhands =
{
	Spellbook="spellbook",
}
------------------------------------------------------------------
--							TOOLS TABLE
------------------------------------------------------------------
LootTable.Equipment.Weapons.Tools =
{
	Crook="tool_crook",
	FishingRod="tool_fishing_rod",
	Hatchet ="tool_hatchet",
	HuntingKnife="tool_hunting_knife",
	MiningPick="tool_mining_pick",
	Torch="tool_torch",
}
------------------------------------------------------------------
--				START OF MAGIC ITEM GENERATION SYSTEM
------------------------------------------------------------------
LootTable.RankInfo =
{
    RankOne   ={MinIntensity=10, MaxIntensity=40,  MinProperties= 1, MaxProperties=1, ItemNameColor="[66CC66]", RankString="Weak Magic Item"},
    RankTwo   ={MinIntensity=10, MaxIntensity=55,  MinProperties= 1, MaxProperties=2, ItemNameColor="[66CCCC]", RankString="Lesser Magic Item"},
    RankThree ={MinIntensity=10, MaxIntensity=70,  MinProperties= 2, MaxProperties=3, ItemNameColor="[6666CC]", RankString="Major Magic Item"},
    RankFour  ={MinIntensity=20, MaxIntensity=85,  MinProperties= 3, MaxProperties=4, ItemNameColor="[FFFF00]", RankString="Greater Magic Item"},
    RankFive  ={MinIntensity=30, MaxIntensity=100, MinProperties= 4, MaxProperties=5, ItemNameColor="[CC9933]", RankString="Amazing Magic Item"},
    RankSix   ={MinIntensity=40, MaxIntensity=100, MinProperties= 5, MaxProperties=5, ItemNameColor="[CC66CC]", RankString="Legendary Magic Item"},    
}
LootTable.RankList = {"RankOne","RankTwo","RankThree","RankFour","RankFive","RankSix",}
LootTable.WeaponProperty1HList =
{
    AccuracyPlus      = 6,
    AttackPlus        = 7,
    CritChancePlus    = 4,
    MaxHealthPlus     = 7,
    MaxManaPlus       = 7,
    MaxStaminaPlus    = 7,
    MaxVitalityPlus   = 4,
    VitalityRegenPlus = 32, --diviser 100
    PowerPlus         = 7,
    ForcePlus         = 7,
    MaxManaPlus       =  14,
}
LootTable.WeaponProp1HList =
{
	"AccuracyPlus","AttackPlus","CritChancePlus",
	"MaxHealthPlus","MaxManaPlus","MaxStaminaPlus",
	"VitalityRegenPlus","MaxVitalityPlus","PowerPlus",
	"ForcePlus",
}
LootTable.WeaponProperty2HList =
{
    AccuracyPlus      = 14,
    AttackPlus        = 16,
    CritChancePlus    = 10,
    MaxHealthPlus     = 16,
    MaxManaPlus       = 16,
    MaxStaminaPlus    = 16,
    MaxVitalityPlus   = 10,
    VitalityRegenPlus = 84, --diviser 100
    PowerPlus         = 16,
    ForcePlus         = 16,
    MaxManaPlus       = 14,
}
LootTable.WeaponProp2HList =
{
	"AccuracyPlus","AttackPlus","CritChancePlus",
	"MaxHealthPlus","MaxManaPlus","MaxStaminaPlus",
	"VitalityRegenPlus","MaxVitalityPlus","PowerPlus",
	"ForcePlus",
}
LootTable.OffHandProperty =
{
    AccuracyPlus      = 4,
    DefensePlus       = 22,
    EvasionPlus       = 22,
    PowerPlus         = 5,
    ForcePlus         = 5,
    MaxVitalityPlus   = 3,
    HealthRegenPlus   = 44, --diviser 100
    ManaRegenPlus     = 44, --diviser 100
    StaminaRegenPlus  = 44, --diviser 100
    VitalityRegenPlus = 22, --diviser 100
}
LootTable.OffHandPropList =
{
	"AccuracyPlus","DefensePlus","EvasionPlus",
	"PowerPlus","ForcePlus","MaxVitalityPlus",
	"HealthRegenPlus","ManaRegenPlus","StaminaRegenPlus",
	"VitalityRegenPlus",
}
LootTable.ArmorPropertyList =
{
    AgilityPlus         = 7,
    ConstitutionPlus    = 6,
    IntelligencePlus    = 7,
    WillPlus            = 6,
    WisdomPlus          = 6,
    StrengthPlus        = 7,
    DefensePlus         = 32,
    EvasionPlus         = 32,
    MaxHealthPlus       = 7,
    MaxManaPlus         = 7,
    MaxStaminaPlus      = 7,
    HealthRegenPlus     = 64, --diviser 100
    ManaRegenPlus       = 64, --diviser 100
    StaminaRegenPlus    = 64, --diviser 100
}
LootTable.ArmorPropList = 
{
    "AgilityPlus","ConstitutionPlus","IntelligencePlus",
    "WillPlus","WisdomPlus","StrengthPlus",
    "DefensePlus","EvasionPlus",
    "MaxHealthPlus","MaxManaPlus","MaxStaminaPlus",
    "HealthRegenPlus","ManaRegenPlus","StaminaRegenPlus",
}

--=========================================
--              GET FUNCTIONS
--=========================================
------------------------------------------------------------------
--@function 
--
--table constructor overload
-- RandomArmor()		this will return a random chest,legs,helm off a random armor table
-- RandomArmor("Plate") this will return a random chest,legs,helm off the Plate list
-- RandomArmor({"Plate","FullPlate","Brigandine"}) this will return a random chest,legs,helm from one of the
--												   Plate,FullPlate,Brigandine lists.
------------------------------------------------------------------
LootTable.Functions.Get.RandomArmor = function(table)
	if(table == nil) then
		local armor_layer = {"Chest","Legs","Head"}
		local armor_list = 
		{
			"Assassin","Bone","Brigandine",
			"Chain","FullPlate","Hardened",
			"Leather","Linen","Padded",
			"Plate","Scale",
		}
		return LootTable.Equipment.Armor[armor_list[math.random(1,#armor_list)]][armor_layer[math.random(1,#armor_layer)]]
	elseif(type(table)=="string") then
		return LootTable.Equipment.Armor[table][armor_layer[math.random(1,#armor_layer)]]
	elseif(type(table)=="table") then
		local armor_list = table
		return LootTable.Equipment.Armor[armor_list[math.random(1,#armor_list)]][armor_layer[math.random(1,#armor_layer)]]
	end
end
------------------------------------------------------------------
--@function 
------------------------------------------------------------------
LootTable.Functions.Get.RandomShield = function()
	local shield_list = {"Buckler","Curved","Kite","Small"}
	return LootTable.Equipment.Armor.Shields[shield_list[math.random(1,#shield_list)]]
end
------------------------------------------------------------------
--@function 
------------------------------------------------------------------
LootTable.Functions.Get.RandomSlashing1H = function()
	local slashing_list = {"Broadsword","Katana","Longsword","Saber"}
	return LootTable.Equipment.Weapons.Slashing1H[slashing_list[math.random(1,#slashing_list)]]
end
------------------------------------------------------------------
--@function 
------------------------------------------------------------------
LootTable.Functions.Get.RandomSlashing2H = function()
	local slashing_list = {"GreatAxe","LargeAxe"}
	return LootTable.Equipment.Weapons.Slashing2H[slashing_list[math.random(1,#slashing_list)]]
end
------------------------------------------------------------------
--@function 
------------------------------------------------------------------
LootTable.Functions.Get.RandomBashing1H = function()
	local bashing_list = {"Mace","Hammer","Maul","WarMace"}
	return LootTable.Equipment.Weapons.Bashing1H[bashing_list[math.random(1,#bashing_list)]]
end
------------------------------------------------------------------
--@function 
------------------------------------------------------------------
LootTable.Functions.Get.RandomBashing2H = function()
	local bashing_list = {"WarHammer","QuarterStaff"}
	return LootTable.Equipment.Weapons.Bashing2H[bashing_list[math.random(1,#bashing_list)]]
end
------------------------------------------------------------------
--@function 
------------------------------------------------------------------
LootTable.Functions.Get.RandomPiercing1H = function()
	local piercing_list = {"Dagger","Kryss","Poniard","BoneDagger"}
	return LootTable.Equipment.Weapons.Piercing1H[piercing_list[math.random(1,#piercing_list)]]
end
------------------------------------------------------------------
--@function 
------------------------------------------------------------------
LootTable.Functions.Get.RandomArchery = function()
	local archery_list = {"BoneBow","LongBow","SavageBow","ShortBow","WarBow"}
	return LootTable.Equipment.Weapons.Archery[archery_list[math.random(1,#archery_list)]]
end
------------------------------------------------------------------
--@function 
------------------------------------------------------------------
LootTable.Functions.Get.RandomLancing = function()
	local lancing_list = {"Halberd","Spear","Vouge","Warfork"}
	return LootTable.Equipment.Weapons.Lancing[lancing_list[math.random(1,#lancing_list)]]
end
------------------------------------------------------------------
--@function 
--
------------------------------------------------------------------
LootTable.Functions.Get.RandomWeapon = function()
	local rndNum = math.random(1,7)
	if(rndNum == 1) then return LootTable.Functions.Get.RandomSlashing1H() end
	if(rndNum == 2) then return LootTable.Functions.Get.RandomSlashing2H() end
	if(rndNum == 3) then return LootTable.Functions.Get.RandomBashing1H() end
	if(rndNum == 4) then return LootTable.Functions.Get.RandomBashing2H() end
	if(rndNum == 5) then return LootTable.Functions.Get.RandomPiercing1H() end
	if(rndNum == 6) then return LootTable.Functions.Get.RandomArchery() end
	if(rndNum == 7) then return LootTable.Functions.Get.RandomLancing() end
	return "weapon_dagger"
end

------------------------------------------------------------------
--@function GetIs2HandedMelee(object)
--@param object - in game object to check if its a 2H weapon
------------------------------------------------------------------
LootTable.Functions.Get.Is2HandedMelee = function(object)
    local list = {1495,1125,1494,1498,1130,1490,1453,1452}
    for i,v in ipairs(list) do
        if(v == object:GetIconId()) then return true end
    end
    return false
end
------------------------------------------------------------------
--@function GetIsRanged(object)
--@param object - in game object to check if its a Ranged weapon
------------------------------------------------------------------
LootTable.Functions.Get.IsRanged = function(object)
    local list = {1145,1338,1340,1334,1337}
    for i,v in ipairs(list) do
        if(v == object:GetIconId()) then return true end
    end
    return false
end
------------------------------------------------------------------
--@function GetIsShield(object)
--@param object - in game object to check if its a Shield
------------------------------------------------------------------
LootTable.Functions.Get.IsShield = function(object)
    local list = {155,127,1519,157}
    for i,v in ipairs(list) do
        if(v == object:GetIconId()) then return true end
    end
    return false
end

------------------------------------------------------------------
--@function LootTable.Functions.BasicSetup(object,rank)
--@param object - in game object to setup basic magic item code
--@param rank   - rank the item is to be generated at
------------------------------------------------------------------
LootTable.Functions.BasicSetup = function(object,rank)
    --include CS tooltips
    SetItemTooltip(object)
    --include MagicProperties Table
    object:SetObjVar("MagicProperties",LootTable.PropertyTable)
    --include record of rank generation
    object:SetObjVar("MagicProperties_Rank",rank)    
    --clean and recolor the name of the object   
end
------------------------------------------------------------------
--@function LootTable.Functions.SetupName(object,rank)
--@param object - in game object to setup basic magic item code
--@param rank   - rank the item is to be generated at
------------------------------------------------------------------
LootTable.Functions.SetupName = function(object,rank)
    local textColor = LootTable.RankInfo[rank].ItemNameColor
    local name = StripColorFromString(object:GetName())
    object:SetName(textColor..name.."[-]")
end
------------------------------------------------------------------
--@function LootTable.Functions.ApplyArmorProperties(object,rank)
--@param object - in game object to setup basic magic item code
--@param rank   - rank the item is to be generated at
------------------------------------------------------------------
LootTable.Functions.ApplyArmorProperties = function(object,rank)
    LootTable.Functions.BasicSetup(object,rank)
    LootTable.Functions.SetupName(object,rank)
    --set color ranking tooltip information
    SetTooltipEntry(object,"rank_string","[i]"..LootTable.RankInfo[rank].ItemNameColor..LootTable.RankInfo[rank].RankString.."[/i][-]",-500)
    
    local itemProperties = object:GetObjVar("MagicProperties")
    local properties = math.random(LootTable.RankInfo[rank].MinProperties,LootTable.RankInfo[rank].MaxProperties)

    for i=1,properties do
        local intensity = math.clamp(math.random(LootTable.RankInfo[rank].MinIntensity,LootTable.RankInfo[rank].MaxIntensity)/100,0.01,1)
        local prop = LootTable.ArmorPropList[math.random(#LootTable.ArmorPropList)]
        itemProperties[prop] = itemProperties[prop] + math.ceil(math.clamp(math.random(1,LootTable.ArmorPropertyList[prop]) * intensity,1,LootTable.ArmorPropertyList[prop]))
    end
    if(itemProperties["HealthRegenPlus"] > 0) then
        itemProperties["HealthRegenPlus"] = math.clamp(itemProperties["HealthRegenPlus"] / 100,0.1,0.6)
    end
    if(itemProperties["ManaRegenPlus"] > 0) then
        itemProperties["ManaRegenPlus"] = math.clamp(itemProperties["ManaRegenPlus"] / 100,0.1,0.6)
    end
    if(itemProperties["StaminaRegenPlus"] > 0) then
        itemProperties["StaminaRegenPlus"] = math.clamp(itemProperties["StaminaRegenPlus"] / 100,0.1,0.6)
    end
    --if we apply item properties, we need to update
    --the tooltip
    object:SetObjVar("MagicProperties",itemProperties)
    LootTable.Functions.UpdateItemTooltip(object)    
end
------------------------------------------------------------------
--@function LootTable.Functions.ApplyOffHandProperties(object,rank)
--@param object - in game object to setup basic magic item code
--@param rank   - rank the item is to be generated at
------------------------------------------------------------------
LootTable.Functions.ApplyOffHandProperties = function(object,rank)
    LootTable.Functions.BasicSetup(object,rank)
    LootTable.Functions.SetupName(object,rank)
    --set color ranking tooltip information
    SetTooltipEntry(object,"rank_string","[i]"..LootTable.RankInfo[rank].ItemNameColor..LootTable.RankInfo[rank].RankString.."[/i][-]",-500)
    
    local itemProperties = object:GetObjVar("MagicProperties")
    local properties = math.random(LootTable.RankInfo[rank].MinProperties,LootTable.RankInfo[rank].MaxProperties)

    for i=1,properties do
        local intensity = math.clamp(math.random(LootTable.RankInfo[rank].MinIntensity,LootTable.RankInfo[rank].MaxIntensity)/100,0.01,1)
        local prop = LootTable.OffHandPropList[math.random(#LootTable.OffHandPropList)]
        itemProperties[prop] = itemProperties[prop] + math.ceil(math.clamp(math.random(1,LootTable.OffHandProperty[prop]) * intensity,1,LootTable.OffHandProperty[prop]))
    end
    if(itemProperties["HealthRegenPlus"] > 0) then
        itemProperties["HealthRegenPlus"] = math.clamp(itemProperties["HealthRegenPlus"] / 100,0.1,0.6)
    end
    if(itemProperties["ManaRegenPlus"] > 0) then
        itemProperties["ManaRegenPlus"] = math.clamp(itemProperties["ManaRegenPlus"] / 100,0.1,0.6)
    end
    if(itemProperties["StaminaRegenPlus"] > 0) then
        itemProperties["StaminaRegenPlus"] = math.clamp(itemProperties["StaminaRegenPlus"] / 100,0.1,0.6)
    end
    if(itemProperties["VitalityRegenPlus"] > 0) then
        itemProperties["VitalityRegenPlus"] = math.clamp(itemProperties["VitalityRegenPlus"] / 100,0.1,0.6)
    end    
    --if we apply item properties, we need to update
    --the tooltip
    object:SetObjVar("MagicProperties",itemProperties)
    LootTable.Functions.UpdateItemTooltip(object)    
end
------------------------------------------------------------------
--@function LootTable.Functions.ApplyWeaponProperties(object,rank)
--@param object - in game object to setup basic magic item code
--@param rank   - rank the item is to be generated at
------------------------------------------------------------------
LootTable.Functions.ApplyWeaponProperties = function(object,rank)
    LootTable.Functions.BasicSetup(object,rank)
    LootTable.Functions.SetupName(object,rank)
    --set color ranking tooltip information
    SetTooltipEntry(object,"rank_string","[i]"..LootTable.RankInfo[rank].ItemNameColor..LootTable.RankInfo[rank].RankString.."[/i][-]",-500)
    
    local itemProperties = object:GetObjVar("MagicProperties")
    local properties = math.random(LootTable.RankInfo[rank].MinProperties,LootTable.RankInfo[rank].MaxProperties)
    local is2Handed = false
    for i=1,properties do
        local intensity = math.clamp(math.random(LootTable.RankInfo[rank].MinIntensity,LootTable.RankInfo[rank].MaxIntensity)/100,0.01,1)
        local prop = LootTable.WeaponProp1HList[math.random(#LootTable.WeaponProp1HList)]
        if(LootTable.Functions.Get.Is2HandedMelee(object) or LootTable.Functions.Get.IsRanged(object)) then
        	is2Handed = true
        	prop = LootTable.WeaponProp2HList[math.random(#LootTable.WeaponProp2HList)]
        end
        if (is2Handed) then
        	itemProperties[prop] = itemProperties[prop] + math.ceil(math.clamp(math.random(1,LootTable.WeaponProperty2HList[prop]) * intensity,1,LootTable.WeaponProperty2HList[prop]))
      	else
        	itemProperties[prop] = itemProperties[prop] + math.ceil(math.clamp(math.random(1,LootTable.WeaponProperty1HList[prop]) * intensity,1,LootTable.WeaponProperty1HList[prop]))
      	end
    end
    if(itemProperties["VitalityRegenPlus"] > 0) then
        itemProperties["VitalityRegenPlus"] = math.clamp(itemProperties["VitalityRegenPlus"] / 100,0.1,0.6)
    end
    --if we apply item properties, we need to update
    --the tooltip
    object:SetObjVar("MagicProperties",itemProperties)
    LootTable.Functions.UpdateItemTooltip(object)    
end

------------------------------------------------------------------
--@function UpdateItemTooltip(object)
--@param object - in game object to setup basic item properties
------------------------------------------------------------------
LootTable.Functions.UpdateItemTooltip = function(object)
	local propertyValues = object:GetObjVar("MagicProperties")
	if(propertyValues == nil) then return end

	local MOVE_SPEED_DIVISOR = 100
	
	if(propertyValues["AccuracyPlus"] ~= 0) then
		SetTooltipEntry(object,"AccuracyPlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["AccuracyPlus"].. "[-]" .. getIf(propertyValues["AccuracyPlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["AccuracyPlus"]>0," +", " ")  ..  propertyValues["AccuracyPlus"].."[-]",210)
	end
	if(propertyValues["AccuracyTimes"] ~= 0) then
		SetTooltipEntry(object,"AccuracyTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["AccuracyTimes"].. "[-]" .. getIf(propertyValues["AccuracyTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["AccuracyTimes"]>0," x", " x") ..  propertyValues["AccuracyTimes"].."[-]",209)
	end
	if(propertyValues["AgilityPlus"] ~= 0) then
		SetTooltipEntry(object,"AgilityPlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["AgilityPlus"].. "[-]" .. getIf(propertyValues["AgilityPlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["AgilityPlus"]>0," +", " ") .. propertyValues["AgilityPlus"].."[-]",200)
	end	
	if(propertyValues["AgilityTimes"] ~= 0) then
		local bonus = propertyValues["AgilityTimes"] * 100
		local bonus_string = bonus.."%"		
		SetTooltipEntry(object,"AgilityTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["AgilityTimes"].. "[-]" .. getIf(propertyValues["AgilityTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["AgilityTimes"]>0," x", " x").. bonus_string.."[-]",199)
	end
	if(propertyValues["AttackPlus"] ~= 0) then
		SetTooltipEntry(object,"AttackPlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["AttackPlus"].. "[-]" .. getIf(propertyValues["AttackPlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["AttackPlus"]>0," +", " ")  ..  propertyValues["AttackPlus"].."[-]",190)
	end
	if(propertyValues["AttackTimes"] ~= 0) then
		SetTooltipEntry(object,"AttackTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["AttackTimes"].. "[-]" .. getIf(propertyValues["AttackTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["AttackTimes"]>0," x", " x") ..  propertyValues["AttackTimes"].."[-]",189)
	end	
	if(propertyValues["PowerPlus"] ~= 0) then
		SetTooltipEntry(object,"PowerPlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["PowerPlus"].. "[-]" .. getIf(propertyValues["PowerPlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["PowerPlus"]>0," +", " ")  ..  propertyValues["PowerPlus"].."[-]",180)
	end
	if(propertyValues["PowerTimes"] ~= 0) then
		SetTooltipEntry(object,"PowerTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["PowerTimes"].. "[-]" .. getIf(propertyValues["PowerTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["PowerTimes"]>0," x", " x") ..  propertyValues["PowerTimes"].."[-]",179)
	end	
	if(propertyValues["ForcePlus"] ~= 0) then
		SetTooltipEntry(object,"ForcePlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["ForcePlus"].. "[-]" .. getIf(propertyValues["ForcePlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["ForcePlus"]>0," +", " ")  ..  propertyValues["ForcePlus"].."[-]",170)
	end
	if(propertyValues["ForceTimes"] ~= 0) then
		SetTooltipEntry(object,"ForceTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["ForceTimes"].. "[-]" .. getIf(propertyValues["ForceTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["ForceTimes"]>0," x", " x") ..  propertyValues["ForceTimes"].."[-]",169)
	end	
	if(propertyValues["ConstitutionPlus"] ~= 0) then
		SetTooltipEntry(object,"ConstitutionPlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["ConstitutionPlus"].. "[-]" .. getIf(propertyValues["ConstitutionPlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["ConstitutionPlus"]>0," +", " ")  ..  propertyValues["ConstitutionPlus"].."[-]",160)
	end
	if(propertyValues["ConstitutionTimes"] ~= 0) then
		SetTooltipEntry(object,"ConstitutionTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["ConstitutionTimes"].. "[-]" .. getIf(propertyValues["ConstitutionTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["ConstitutionTimes"]>0," x", " x") ..  propertyValues["ConstitutionTimes"].."[-]",159)
	end	
	if(propertyValues["CritChancePlus"] ~= 0) then
		SetTooltipEntry(object,"CritChancePlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["CritChancePlus"].. "[-]" .. getIf(propertyValues["CritChancePlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["CritChancePlus"]>0," +", " ")  ..  propertyValues["CritChancePlus"].."[-]",150)
	end
	if(propertyValues["CritChanceTimes"] ~= 0) then
		SetTooltipEntry(object,"CritChanceTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["CritChanceTimes"].. "[-]" .. getIf(propertyValues["CritChanceTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["CritChanceTimes"]>0," x", " x") ..  propertyValues["CritChanceTimes"].."[-]",149)
	end	
	if(propertyValues["DefensePlus"] ~= 0) then
		SetTooltipEntry(object,"DefensePlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["DefensePlus"].. "[-]" .. getIf(propertyValues["DefensePlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["DefensePlus"]>0," +", " ")  ..  propertyValues["DefensePlus"].."[-]",140)
	end
	if(propertyValues["DefenseTimes"] ~= 0) then
		SetTooltipEntry(object,"DefenseTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["DefenseTimes"].. "[-]" .. getIf(propertyValues["DefenseTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["DefenseTimes"]>0," x", " x") ..  propertyValues["DefenseTimes"].."[-]",139)
	end	
	if(propertyValues["EvasionPlus"] ~= 0) then
		SetTooltipEntry(object,"EvasionPlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["EvasionPlus"].. "[-]" .. getIf(propertyValues["EvasionPlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["EvasionPlus"]>0," +", " ")  ..  propertyValues["EvasionPlus"].."[-]",130)
	end
	if(propertyValues["EvasionTimes"] ~= 0) then
		SetTooltipEntry(object,"EvasionTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["EvasionTimes"].. "[-]" .. getIf(propertyValues["EvasionTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["EvasionTimes"]>0," x", " x") ..  propertyValues["EvasionTimes"].."[-]",129)
	end	
	if(propertyValues["IntelligencePlus"] ~= 0) then
		SetTooltipEntry(object,"IntelligencePlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["IntelligencePlus"].. "[-]" .. getIf(propertyValues["IntelligencePlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["IntelligencePlus"]>0," +", " ")  ..  propertyValues["IntelligencePlus"].."[-]",120)
	end
	if(propertyValues["IntelligenceTimes"] ~= 0) then
		local bonus = propertyValues["IntelligenceTimes"] * 100
		local bonus_string = bonus.."%"			
		SetTooltipEntry(object,"IntelligenceTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["IntelligenceTimes"].. "[-]" .. getIf(propertyValues["IntelligenceTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["IntelligenceTimes"]>0," x", " x").. bonus_string.."[-]",119)
	end	
	if(propertyValues["StrengthPlus"] ~= 0) then
		SetTooltipEntry(object,"StrengthPlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["StrengthPlus"].. "[-]" .. getIf(propertyValues["StrengthPlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["StrengthPlus"]>0," +", " ")  ..  propertyValues["StrengthPlus"].."[-]",110)
	end
	if(propertyValues["StrengthTimes"] ~= 0) then
		local bonus = propertyValues["StrengthTimes"] * 100
		local bonus_string = bonus.."%" 
		SetTooltipEntry(object,"StrengthTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["StrengthTimes"].. "[-]" .. getIf(propertyValues["StrengthTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["StrengthTimes"]>0," x", " x").. bonus_string.."[-]",109)
	end	
	if(propertyValues["WillPlus"] ~= 0) then
		SetTooltipEntry(object,"WillPlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["WillPlus"].. "[-]" .. getIf(propertyValues["WillPlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["WillPlus"]>0," +", " ")  ..  propertyValues["WillPlus"].."[-]",100)
	end
	if(propertyValues["WillTimes"] ~= 0) then
		SetTooltipEntry(object,"WillTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["WillTimes"].. "[-]" .. getIf(propertyValues["WillTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["WillTimes"]>0," x", " x") ..  propertyValues["WillTimes"].."[-]",99)
	end	
	if(propertyValues["WisdomPlus"] ~= 0) then
		SetTooltipEntry(object,"WisdomPlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["WisdomPlus"].. "[-]" .. getIf(propertyValues["WisdomPlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["WisdomPlus"]>0," +", " ")  ..  propertyValues["WisdomPlus"].."[-]",90)
	end
	if(propertyValues["WisdomTimes"] ~= 0) then
		SetTooltipEntry(object,"WisdomTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["WisdomTimes"].. "[-]" .. getIf(propertyValues["WisdomTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["WisdomTimes"]>0," x", " x") ..  propertyValues["WisdomTimes"].."[-]",89)
	end	
	if(propertyValues["MaxHealthPlus"] ~= 0) then
		SetTooltipEntry(object,"MaxHealthPlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["MaxHealthPlus"].. "[-]" .. getIf(propertyValues["MaxHealthPlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["MaxHealthPlus"]>0," +", " ")  ..  propertyValues["MaxHealthPlus"].."[-]",80)
	end
	if(propertyValues["MaxHealthTimes"] ~= 0) then
		SetTooltipEntry(object,"MaxHealthTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["MaxHealthTimes"].. "[-]" .. getIf(propertyValues["MaxHealthTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["MaxHealthTimes"]>0," x", " x") ..  propertyValues["MaxHealthTimes"].."[-]",79)
	end	
	if(propertyValues["MaxManaPlus"] ~= 0) then
		SetTooltipEntry(object,"MaxManaPlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["MaxManaPlus"].. "[-]" .. getIf(propertyValues["MaxManaPlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["MaxManaPlus"]>0," +", " ")  ..  propertyValues["MaxManaPlus"].."[-]",70)
	end
	if(propertyValues["MaxManaTimes"] ~= 0) then
		SetTooltipEntry(object,"MaxManaTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["MaxManaTimes"].. "[-]" .. getIf(propertyValues["MaxManaTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["MaxManaTimes"]>0," x", " x") ..  propertyValues["MaxManaTimes"].."[-]",69)
	end	
	if(propertyValues["MaxStaminaPlus"] ~= 0) then
		SetTooltipEntry(object,"MaxStaminaPlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["MaxStaminaPlus"].. "[-]" .. getIf(propertyValues["MaxStaminaPlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["MaxStaminaPlus"]>0," +", " ")  ..  propertyValues["MaxStaminaPlus"].."[-]",60)
	end
	if(propertyValues["MaxStaminaTimes"] ~= 0) then
		SetTooltipEntry(object,"MaxStaminaTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["MaxStaminaTimes"].. "[-]" .. getIf(propertyValues["MaxStaminaTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["MaxStaminaTimes"]>0," x", " x") ..  propertyValues["MaxStaminaTimes"].."[-]",59)
	end	
	if(propertyValues["MaxVitalityPlus"] ~= 0) then
		SetTooltipEntry(object,"MaxVitalityPlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["MaxVitalityPlus"].. "[-]" .. getIf(propertyValues["MaxVitalityPlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["MaxVitalityPlus"]>0," +", " ")  ..  propertyValues["MaxVitalityPlus"].."[-]",50)
	end
	if(propertyValues["MaxVitalityTimes"] ~= 0) then
		SetTooltipEntry(object,"MaxVitalityTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["MaxVitalityTimes"].. "[-]" .. getIf(propertyValues["MaxVitalityTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["MaxVitalityTimes"]>0," x", " x") ..  propertyValues["MaxVitalityTimes"].."[-]",49)
	end	
	if(propertyValues["HealthRegenPlus"] ~= 0) then
		SetTooltipEntry(object,"HealthRegenPlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["HealthRegenPlus"].. "[-]" .. getIf(propertyValues["HealthRegenPlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["HealthRegenPlus"]>0," +", " ")  ..  propertyValues["HealthRegenPlus"].."[-]",40)
	end
	if(propertyValues["HealthRegenTimes"] ~= 0) then
		SetTooltipEntry(object,"HealthRegenTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["HealthRegenTimes"].. "[-]" .. getIf(propertyValues["HealthRegenTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["HealthRegenTimes"]>0," x", " x") ..  propertyValues["HealthRegenTimes"].."[-]",39)
	end	
	if(propertyValues["ManaRegenPlus"] ~= 0) then
		SetTooltipEntry(object,"ManaRegenPlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["ManaRegenPlus"].. "[-]" .. getIf(propertyValues["ManaRegenPlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["ManaRegenPlus"]>0," +", " ")  ..  propertyValues["ManaRegenPlus"].."[-]",30)
	end
	if(propertyValues["ManaRegenTimes"] ~= 0) then
		SetTooltipEntry(object,"ManaRegenTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["ManaRegenTimes"].. "[-]" .. getIf(propertyValues["ManaRegenTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["ManaRegenTimes"]>0," x", " x") ..  propertyValues["ManaRegenTimes"].."[-]",29)
	end
	if(propertyValues["StaminaRegenPlus"] ~= 0) then
		SetTooltipEntry(object,"StaminaRegenPlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["StaminaRegenPlus"].. "[-]" .. getIf(propertyValues["StaminaRegenPlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["StaminaRegenPlus"]>0," +", " ")  ..  propertyValues["StaminaRegenPlus"].."[-]",28)
	end
	if(propertyValues["StaminaRegenTimes"] ~= 0) then
		SetTooltipEntry(object,"StaminaRegenTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["StaminaRegenTimes"].. "[-]" .. getIf(propertyValues["StaminaRegenTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["StaminaRegenTimes"]>0," x", " x") ..  propertyValues["StaminaRegenTimes"].."[-]",27)
	end		
	if(propertyValues["VitalityRegenPlus"] ~= 0) then
		SetTooltipEntry(object,"VitalityRegenPlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["VitalityRegenPlus"].. "[-]" .. getIf(propertyValues["VitalityRegenPlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["VitalityRegenPlus"]>0," +", " ")  ..  propertyValues["VitalityRegenPlus"].."[-]",25)
	end
	if(propertyValues["VitalityRegenTimes"] ~= 0) then
		SetTooltipEntry(object,"VitalityRegenTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["VitalityRegenTimes"].. "[-]" .. getIf(propertyValues["VitalityRegenTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["VitalityRegenTimes"]>0," x", " x") ..  propertyValues["VitalityRegenTimes"].."[-]",24)
	end	
	if(propertyValues["MoveSpeedPlus"] ~= 0) then
		SetTooltipEntry(object,"MoveSpeedPlus",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["MoveSpeedPlus"].. "[-]" .. getIf(propertyValues["MoveSpeedPlus"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["MoveSpeedPlus"]>0," +", " ") ..  propertyValues["MoveSpeedPlus"] * MOVE_SPEED_DIVISOR .. "%".."[-]",20)
	end
	if(propertyValues["MoveSpeedTimes"] ~= 0) then
		SetTooltipEntry(object,"MoveSpeedTimes",LootTable.TextColors.PropertyColor..LootTable.PropertyBonusStrings["MoveSpeedTimes"].. "[-]" .. getIf(propertyValues["MoveSpeedTimes"]>0,LootTable.TextColors.PropertyValueColor,LootTable.TextColors.PropertyValueColorNegative) .. getIf(propertyValues["MoveSpeedTimes"]>0," x", " x")..  propertyValues["MoveSpeedTimes"] * MOVE_SPEED_DIVISOR .. "%".."[-]",19)
	end	
	if(object:HasObjVar("LoreString")) then
		SetTooltipEntry(object,"ItemLoreSpace","",-1001)
		SetTooltipEntry(object,"ItemLore",object:GetObjVar("LoreString").. "[-]",-1000)
	end
end




