-- written by Gizmo
----------------------------------------------------------------------
-- If you like Project Phoenix and want to help support the project
-- you could send any donation amount to jessebutler1975@gmail.com at
-- paypal.com
--
-- Thank you for using my product, 
-- I hope you enjoy it as much as I do
----------------------------------------------------------------------
----------------------------------------------------------
--@function OnItemEquip(item)
--@param item - the item your checking for item properties
----------------------------------------------------------
function OnItemEquip(item)
	local propertyValues = item:GetObjVar("MagicProperties")
	if(propertyValues == nil) then return end
	--fix health/mana/stamina values when equipping new items.
	for k,v in pairs(propertyValues) do
		SetMobileMod(this,k,item.Id..k,v)
		if(k=="ConstitutionPlus" or "ConstitutionTimes" or "MaxHealthPlus" or "MaxHealthTimes") then
			CallFunctionDelayed(TimeSpan.FromMilliseconds(50),function() SetCurHealth(this,GetCurHealth(this)+v) end)
		end
		if(k=="IntelligencePlus" or "IntelligenceTimes" or "MaxManaPlus" or "MaxManaTimes") then
			CallFunctionDelayed(TimeSpan.FromMilliseconds(50),function() SetCurMana(this,GetCurMana(this)+v) end)
		end
		if(k=="AgilityPlus" or "AgilityTimes" or "MaxStaminaPlus" or "MaxStaminaTimes") then
			CallFunctionDelayed(TimeSpan.FromMilliseconds(50),function() SetCurStamina(this,GetCurStamina(this)+v) end)
		end
	end
end
----------------------------------------------------------
--@function OnItemUnEquip(item)
--@param item - the item your checking for item properties
----------------------------------------------------------
function OnItemUnEquip(item)
	local propertyValues = item:GetObjVar("MagicProperties")
	if(propertyValues == nil) then return end
	for k,v in pairs(propertyValues) do
		SetMobileMod(this,k,item.Id..k,nil)
	end
end
----------------------------------------------------------
--@function ValidateEquipmentMagicalProperties()
--validates the current magic items worn, fires
--in the onload event.
----------------------------------------------------------
function ValidateEquipmentMagicalProperties()
	local headSlot = this:GetEquippedObject("Head")
	local bodySlot = this:GetEquippedObject("Chest")
	local legSlot = this:GetEquippedObject("Legs")
	local leftHandSlot = this:GetEquippedObject("LeftHand")
	local rightHandSlot = this:GetEquippedObject("RightHand")

	if(headSlot ~= nil) then
		if(headSlot:HasObjVar("MagicProperties"))then OnItemEquip(headSlot) end
	end
	if(bodySlot ~= nil) then
		if(bodySlot:HasObjVar("MagicProperties")) then OnItemEquip(bodySlot) end
	end
	if(legSlot ~= nil) then
		if(legSlot:HasObjVar("MagicProperties")) then OnItemEquip(legSlot) end
	end	
	if(leftHandSlot ~= nil) then
		if(leftHandSlot:HasObjVar("MagicProperties")) then OnItemEquip(leftHandSlot) end
	end
	if(rightHandSlot ~= nil) then
		if(rightHandSlot:HasObjVar("MagicProperties")) then OnItemEquip(rightHandSlot)  end
	end	
end
----------------------------------------------------------
--EVENTTYPE - ItemEquipped 
----------------------------------------------------------
RegisterEventHandler(EventType.ItemEquipped, "", 
function(item)
	if ( item ~= nil ) then
		if(item:HasObjVar("MagicProperties")) then
			OnItemEquip(item)
		end
	end
end)
----------------------------------------------------------
--EVENTTYPE - ItemUnequipped 
----------------------------------------------------------
RegisterEventHandler(EventType.ItemUnequipped, "", 
function(item)
	if ( item ~= nil ) then
		if(item:HasObjVar("MagicProperties")) then
			OnItemUnEquip(item)
		end
	end
end)
----------------------------------------------------------
--EVENTTYPE - LoadFromBackup 
----------------------------------------------------------
RegisterEventHandler(EventType.LoadedFromBackup,"",
function()
	--For ItemProperty Login Validation
	ValidateEquipmentMagicalProperties()
end)
