-- written by Gizmo
----------------------------------------------------------------------
-- If you like Project Phoenix and want to help support the project
-- you could send any donation amount to jessebutler1975@gmail.com at
-- paypal.com
--
-- Thank you for using my product, 
-- I hope you enjoy it as much as I do
----------------------------------------------------------------------
function ShowProjectPhoenixAdminWindow()
	dynWindow = nil
	local dynWindow = DynamicWindow("ProjectPhoenixAdminWindow","Project Phoenix Admin",480,380,-200,-200,"Transparent","Bottom")
	dynWindow:AddImage(0,0,"Blank",500,70,"Sliced","151515")
	dynWindow:AddImage(0,0,"SectionDividerFrames_nobackground",500,70,"Sliced","FFFF00")
	dynWindow:AddUserAction(10,10,
		{
			ID="CreateSpawner",
			ActionType="CreateSpawner",
			DisplayName="Create Spawner",
			Tooltip="This will create a spawner at the targeted location",
			Icon="Magic Barrier",
			ServerCommand="CreateSpawner",
			Enabled=true
		})
	dynWindow:AddUserAction(55,10,
		{
			ID="CreateRegion",
			ActionType="CreateRegion",
			DisplayName="Create Region",
			Tooltip="This will create a region at the targeted location.",
			Icon="Night",
			ServerCommand="CreateRegion",
			Enabled=true
		})
	dynWindow:AddUserAction(100,10,
		{
			ID="CreateMerchantMale",
			ActionType="CreateMerchantMale",
			DisplayName="Create Male Merchant",
			Tooltip="This will create a new male merchant at the targeted location.",
			Icon="Fire Mastery",
			ServerCommand="CreateMerchantMale",
			Enabled=true
		})
	dynWindow:AddUserAction(145,10,
		{
			ID="CreateMerchantFemale",
			ActionType="CreateMerchantFemale",
			DisplayName="Create Female Merchant",
			Tooltip="This will create a new female merchant at the targeted location.",
			Icon="Unholy Mastery",
			ServerCommand="CreateMerchantFemale",
			Enabled=true
		})	
	this:OpenDynamicWindow(dynWindow)
end

RegisterEventHandler(EventType.DynamicWindowResponse,"ProjectPhoenixAdminWindow",
	function (user,buttonId,fieldData)
		if(buttonId == "Args") then

		end
	end)

----------------------------------------------------------------------------------------
--							 CREATE SPAWNER EVENT HANDLERS
----------------------------------------------------------------------------------------
RegisterEventHandler(EventType.ClientUserCommand,"CreateSpawner",
 	function()
		this:RequestClientTargetLoc(this,"placeSpawner")
        this:SystemMessage("select a location to place the spawner")
 	end)

RegisterEventHandler(EventType.ClientTargetLocResponse,"placeSpawner",
	function(success,location)
		if(success and location ~= nil) then
			CreateObj("spawner",location,"OnCreateSpawner")
			PlayEffectAtLoc("TeleportFromEffect",location,0)
		else
			this:SystemMessage("[FF7700]ERROR: bad placement, try again")
			this:RequestClientTargetLoc(this,"placeSpawner")
		end
	end)

----------------------------------------------------------------------------------------
--							 CREATE REGION EVENT HANDLERS
----------------------------------------------------------------------------------------
RegisterEventHandler(EventType.ClientUserCommand,"CreateRegion",
 	function()
		this:RequestClientTargetLoc(this,"placeRegion")
        this:SystemMessage("select a location to place the region")
 	end)

RegisterEventHandler(EventType.ClientTargetLocResponse,"placeRegion",
	function(success,location)
		if(success and location ~= nil) then
			CreateObj("region",location,"OnCreateRegion")
			PlayEffectAtLoc("TeleportFromEffect",location,0)
		else
			this:SystemMessage("[FF7700]ERROR: bad placement, try again")
			this:RequestClientTargetLoc(this,"placeRegion")
		end
	end)

----------------------------------------------------------------------------------------
--							 CREATE CreateMerchantMale EVENT HANDLERS
----------------------------------------------------------------------------------------
RegisterEventHandler(EventType.ClientUserCommand,"CreateMerchantMale",
 	function()
		this:RequestClientTargetLoc(this,"placeMerchantMale")
        this:SystemMessage("select a location to place the merchant")
 	end)

RegisterEventHandler(EventType.ClientTargetLocResponse,"placeMerchantMale",
	function(success,location)
		if(success and location ~= nil) then
			CreateObj("merchant_male",location,"OnCreateMerchantMale")
			PlayEffectAtLoc("TeleportFromEffect",location,0)
		else
			this:SystemMessage("[FF7700]ERROR: bad placement, try again")
			this:RequestClientTargetLoc(this,"placeMerchantMale")
		end
	end)

----------------------------------------------------------------------------------------
--							 CREATE CreateMerchantFemale EVENT HANDLERS
----------------------------------------------------------------------------------------
RegisterEventHandler(EventType.ClientUserCommand,"CreateMerchantFemale",
 	function()
		this:RequestClientTargetLoc(this,"placeMerchantFemale")
        this:SystemMessage("select a location to place the merchant")
 	end)

RegisterEventHandler(EventType.ClientTargetLocResponse,"placeMerchantFemale",
	function(success,location)
		if(success and location ~= nil) then
			CreateObj("merchant_female",location,"OnCreateMerchantFemale")
			PlayEffectAtLoc("TeleportFromEffect",location,0)
		else
			this:SystemMessage("[FF7700]ERROR: bad placement, try again")
			this:RequestClientTargetLoc(this,"placeMerchantFemale")
		end
	end)

RegisterEventHandler(EventType.ClientObjectCommand,"dropAction",
	function (user,sourceId,actionType,actionId,slot)
		-- print(user,sourceId,actionType,actionId,slot)

		if(actionType == "CreateSpawner" and slot ~= nil) then
			local userAction = 
			{
				ID="CreateSpawner",
				ActionType="CreateSpawner",
				DisplayName="Create Spawner",
				Tooltip="This will create a spawner at the targeted location.",
				Icon="Magic Barrier",
				ServerCommand="CreateSpawner",
				Enabled=true
			}
			userAction.Slot = tonumber(slot)
			AddUserActionToSlot(userAction)
		end
		if(actionType=="CreateSpawner" and slot == nil) then
			RemoveUserActionFromSlot(sourceId.Slot)
		end

		if(actionType == "CreateRegion" and slot ~= nil) then
			local userAction = 
			{
				ID="CreateRegion",
				ActionType="CreateRegion",
				DisplayName="Create Region",
				Tooltip="This will create a region at the targeted location.",
				Icon="Night",
				ServerCommand="CreateRegion",
				Enabled=true
			}
			userAction.Slot = tonumber(slot)
			AddUserActionToSlot(userAction)
		end
		if(actionType=="CreateRegion" and slot == nil) then
			RemoveUserActionFromSlot(sourceId.Slot)
		end
		
		if(actionType == "CreateMerchantMale" and slot ~= nil) then
			local userAction = 
			{
				ID="CreateMerchantMale",
				ActionType="CreateMerchantMale",
				DisplayName="Create Male Merchant",
				Tooltip="This will create a new male merchant at the targeted location.",
				Icon="Fire Mastery",
				ServerCommand="CreateMerchantMale",
				Enabled=true
			}
			userAction.Slot = tonumber(slot)
			AddUserActionToSlot(userAction)
		end
		if(actionType=="CreateMerchantMale" and slot == nil) then
			RemoveUserActionFromSlot(sourceId.Slot)
		end	
		if(actionType == "CreateMerchantFemale" and slot ~= nil) then
			local userAction = 
			{
				ID="CreateMerchantFemale",
				ActionType="CreateMerchantFemale",
				DisplayName="Create Female Merchant",
				Tooltip="This will create a new female merchant at the targeted location.",
				Icon="Unholy Mastery",
				ServerCommand="CreateMerchantFemale",
				Enabled=true
			}
			userAction.Slot = tonumber(slot)
			AddUserActionToSlot(userAction)
		end
		if(actionType=="CreateMerchantFemale" and slot == nil) then
			RemoveUserActionFromSlot(sourceId.Slot)
		end					
	end)

RegisterCommand{ Command="admin", AccessLevel = AccessLevel.God, Func=ShowProjectPhoenixAdminWindow, Desc="project phoenix administration dynamic window" }