-- written by Gizmo
----------------------------------------------------------------------
-- If you like Project Phoenix and want to help support the project
-- you could send any donation amount to jessebutler1975@gmail.com at
-- paypal.com
--
-- Thank you for using my product, 
-- I hope you enjoy it as much as I do
----------------------------------------------------------------------
-----------------------------------------------------------------------------------
--									  Requirements
-----------------------------------------------------------------------------------

require 'quest_npc_dialog_window'

-----------------------------------------------------------------------------------
--										Globals
-----------------------------------------------------------------------------------
SelectedBodyType = 1
SelectedHairType = 1
SelectedHairColorType = 1
FullBody = false

QuestGiverCustomization = {
	BodyTypesMale = {
		{Name = "Male A",Template = "head_male02"},
		{Name = "Male B",Template = "head_male02"},
		{Name = "Male C",Template = "head_male03"},
		{Name = "Male D",Template = "head_male04"},
		{Name = "Male E",Template = "head_male05"},
	},
	BodyTypesFemale = {
		{Name = "Female A",Template = "head_female01"},
		{Name = "Female B",Template = "head_female02"},
		{Name = "Female C",Template = "head_female03"},
		{Name = "Female D",Template = "head_female04"},
		{Name = "Female E",Template = "head_female05"},
	},
	HairTypesMale = {
		{Name = "Regular",Template = "hair_male"},
		{Name = "Bangs",Template = "hair_male_bangs"},
		{Name = "Buzzcut",Template = "hair_male_buzzcut"},
		{Name = "Bald"},
		{Name = "Messy",Template = "hair_male_messy"},
		{Name = "Nobleman",Template = "hair_male_nobleman"},
		{Name = "Roguish",Template = "hair_male_rougish"},
		{Name = "Side-Undercut",Template = "hair_male_sideundercut"},
		{Name = "Undercut",Template = "hair_male_undercut"},
		{Name = "Windswept",Template = "hair_male_windswept"},
		--{Name = "Long",Template = "hair_male_long"},
	},
	HairTypesFemale = {
		{Name = "Pony-Tail A",Template = "hair_female"},
		{Name = "Bob",Template = "hair_female_bob"},
		{Name = "Bun",Template = "hair_female_bun"},
		{Name = "Buzzcut",Template = "hair_female_buzzcut"},
		{Name = "Pigtails",Template = "hair_female_pigtails"},
		{Name = "Pony-Tail B",Template = "hair_female_ponytail"},
		{Name = "Shaggy",Template = "hair_female_shaggy"},
		{Name = "Bald"},
	},
	HairColorTypes = {
		{Name = "Dark Brown", Color = "0xFF554838"},
		{Name = "Brown", Color = "0xFFA56B46"},
		{Name = "Light-Brown", Color = "0xFFA7856A"},
		{Name = "Red", Color = "0xFFB55239"},
		{Name = "Black", Color = "0xFF191919"},
		{Name = "Gray", Color = "0xFFB7A69E"},
		{Name = "Blonde", Color = "0xFFB9B184"},
		{Name = "Dark Red", Color = "0xFF380000"},
		{Name = "Orange", Color = "0xFFFF7F00"},
		{Name = "White", Color = "0xFFFFFFFF"},
		{Name = "Purple", Color = "0xFF990099"},
		{Name = "Dark Blue", Color = "0xFF012265"},
		{Name = "Green", Color = "0xFF339933"},
		{Name = "Blue", Color = "0xFF3399FF"},
		{Name = "Pink", Color = "0xFFFF66A3"},
	},
	StartingGear = {
		{ Name = "Warrior", Template = "startinggear_warrior" },
		{ Name = "Rogue", Template = "startinggear_rogue" },
		{ Name = "Archer", Template = "startinggear_archer" },
		{ Name = "Mage", Template = "startinggear_mage" },
		{ Name = "Tamer", Template = "startinggear_tamer" },
		--{ Name = "Bard", Template = "startinggear_bard" },
		{ Name = "Craftsman", Template = "startinggear_craftsman" }
	},
}

-----------------------------------------------------------------------------------
--									Core Functions
-----------------------------------------------------------------------------------

--GetAttention
-- A simple function to force a mobile to face another mobile.
function GetAttention(user)
    this:StopMoving()
    this:SetFacing(this:GetLoc():YAngleTo(user:GetLoc()))
end

--RewardPlayer
-- quest - a string value ex. "LongDrawnOutQuest"
--
-- this function will create the reward bag, and pass the
-- quest, reward_table, player to the "QuestBagCreated"
-- event to process the rewards into the bag.
function RewardPlayer(player,quest)
	local reward_table = CustomQuests.Quests[quest].Rewards or nil
	if(reward_table == nil) then return end
	local backpack = player:GetEquippedObject("Backpack")
	if(backpack == nil) then return end
	CreateObjInContainer("pouch", backpack, GetRandomDropPosition(backpack), "QuestBagCreated", quest, reward_table, player)
end


--ShowCustomWindow
--This is a simple ui for admins to change the looks of the npc
--this was originally in the CS Code base, I just modified some
--parts so nothing fancy but it works for now.
function ShowCustomWindow(user)
	if (IsMale(this)) then
		GenderBodyTable = QuestGiverCustomization.BodyTypesMale
		GenderHairTable = QuestGiverCustomization.HairTypesMale
	end
	if (IsFemale(this)) then
		GenderBodyTable = QuestGiverCustomization.BodyTypesFemale
		GenderHairTable = QuestGiverCustomization.HairTypesFemale
	end

	if (GenderHairTable == nil or GenderBodyTable == nil) then
		DebugMessage("[custom_char_window|QuestNpcCustomWindow] ERROR: Player has unsupported gender/body type.")
		return
	end

	local dynWindow = DynamicWindow("QuestNpcCustomWindow","Appearance",320,600,-160,-290,"Default","Center")

	if (FullBody == false) then
		dynWindow:AddImage(27-5,25-5+13,"SkillTracker_BG",255,255,"Sliced")
		dynWindow:AddPortrait(27,25+13,245,245,this,"head",false)		
		dynWindow:AddButton(61, 0, "FullBody", "Zoom Out", 180, 20, "Switch to seeing the full body.", "", false,"")
	else
		dynWindow:AddPortrait(60,20,180,270,this,"full",false)	
		dynWindow:AddButton(61, 0, "FullBody", "Zoom In", 180, 20, "Switch to zoom in on your head.", "", false,"")
	end
	dynWindow:AddImage(8,302,"BasicWindow_Panel",284,224,"Sliced")
	--body type tab
	dynWindow:AddImage(25,306+6,"SkillTracker_BG",250,55,"Sliced")
	dynWindow:AddLabel(155,310+10,"[F3F781]Body[-]",323,0,23,"center")
	dynWindow:AddButton(35,335-2,"BodyLeft","",0,0,"","",false,"Previous")
	dynWindow:AddLabel(155,335+10,GenderBodyTable[SelectedBodyType].Name,323,0,18,"center")
	dynWindow:AddButton(255,335-2,"BodyRight","",0,0,"","",false,"Next")
	--hair tab
	dynWindow:AddImage(25,361+6,"SkillTracker_BG",250,55,"Sliced")
	dynWindow:AddLabel(155,365+10,"[F3F781]Hair[-]",323,0,23,"center")
	dynWindow:AddButton(35,390-2,"HairLeft","",0,0,"","",false,"Previous")
	dynWindow:AddLabel(155,390+10,GenderHairTable[SelectedHairType].Name,323,0,18,"center")
	dynWindow:AddButton(255,390-2,"HairRight","",0,0,"","",false,"Next")
	--hair color
	dynWindow:AddImage(25,416+6,"SkillTracker_BG",250,55,"Sliced")
	dynWindow:AddLabel(155,420+10,"[F3F781]Hair Color[-]",323,0,23,"center")
	dynWindow:AddButton(35,445-2,"HairColorLeft","",0,0,"","",false,"Previous")
	dynWindow:AddLabel(155,445+10,QuestGiverCustomization.HairColorTypes[SelectedHairColorType].Name,323,0,18,"center")
	dynWindow:AddButton(255,445-2,"HairColorRight","",0,0,"","",false,"Next")

	dynWindow:AddButton(61, 485, "ChangeApperance", "Accept", 180, 30, "Change the apperance of your character.", "", true,"")
			
	user:OpenDynamicWindow(dynWindow,this)	
end

-----------------------------------------------------------------------------------
--									Event Handlers
-----------------------------------------------------------------------------------

--this fires when the NPC's hair is created.
RegisterEventHandler(EventType.CreatedObject,"CreatedHair",
	function(user)
		local currentEquipped = this:GetEquippedObject("BodyPartHair")
		currentEquipped:SetHue(QuestGiverCustomization.HairColorTypes[SelectedHairColorType].Color)--set the equipped object to the template in the index
	end)

--this fires when the reward bag is given to the player.
RegisterEventHandler(EventType.CreatedObject, "QuestBagCreated", 
	function(success,objRef,quest,rewardtable,player)
		if( success == true ) then
			local bagcolor = 
			{
				{42,"772211"},
				{42,"112277"},
				{42,"771122"},
				{42,"117722"},
				{42,"883322"},
				{42,"223388"},
				{42,"882233"},
				{42,"228833"},
				{42,"994433"},
				{42,"334499"},
				{42,"993344"},
				{42,"994433"},
			}
			local dayofweek =
			{
				Sunday = "Sunday",
				Monday = "Monday",
				Tuesday = "Tuesday",
				Wednesday = "Wednesday",
				Thursday = "Thursday",
				Friday = "Friday",
				Saturday = "Saturday",
			}
			local month =
			{
				January = "January",
				February = "February",
				March = "March",
				April = "April",
				May = "May",
				June = "June",
				July = "July",
				August = "August",
				September = "September",
				October = "October",
				November = "November",
				December = "December",
			}
			local color = bagcolor[math.random(#bagcolor)]
			objRef:SetHue(color[1])
			objRef:SetColor(color[2])
			objRef:SetName("[008800]Reward Bag[FFFFFF]")
			SetTooltipEntry(objRef,"quest_name","[CCBB44]for completing the quest\n[b][FFDD22]"..CustomQuests.Quests[quest].Title.."[/b]",50)
			SetTooltipEntry(objRef,"player_name","[CCBB44]completed by [b][AA9922]" .. player:GetName() .. "[/b]",49)
			SetTooltipEntry(objRef,"date_time","[CCBB44]on [AA9922]"..os.date("%x").."[FFFFFF]" ,48)
			
			for i,val in pairs(rewardtable) do
				if(val.Type == "item") then
					local template = val.Template or nil
					local amount = val.Amount or 1
					local chance = val.Chance or 1
					if(math.random() <= (chance/1)) then
						CreateObjInContainer(template, objRef, GetRandomDropPosition(objRef), "QuestItemCreated", amount)
					end
				elseif(val.Type == "coins") then
					local min = val.MinAmount or nil
					local max = val.MaxAmount or nil
					local amount = val.Amount or nil
					if(amount ~= nil) then
						CreateObjInContainer("coin_purse", objRef, GetRandomDropPosition(objRef), "QuestItemCreated", amount)
					else
						if(min ~= nil and max ~= nil) then
							CreateObjInContainer("coin_purse", objRef, GetRandomDropPosition(objRef), "QuestItemCreated", math.random(min,max))
						end
					end
				elseif(val.Type == "faction") then
					Systems_Factions.AdjustFaction(player,val.Faction,val.Value,val.Cap)
					player:SystemMessage("[BBBB11]you have earned [FFFFFF]"..val.Value.." [FF7700]"..val.Faction.."[BBBB11] faction.")
				elseif(val.Type == "objvar") then
					local name = val.Name or ""
					local plus = val.Plus or nil
					local minus = val.Minus or nil
					local value = val.Value or nil

					if not(player:HasObjVar(name)) then
						if(plus ~= nil) then
							player:SetObjVar(name,plus[1])
						elseif(minus ~= nil) then
							player:SetObjVar(name,minus[1])
						elseif(value ~= nil) then
							player:SetObjVar(name,value)
						end
					else
						local objvar_value = player:GetObjVar(name)
						if(plus ~= nil) then
							local plus_value = plus[1] or 0
							local plus_cap = plus[2] or 0
							objvar_value = objvar_value + plus_value
							if(objvar_value > plus_cap) then objvar_value = plus_cap end
							player:SetObjVar(name,objvar_value)
						elseif(minus ~= nil) then
							local minus_value = minus[1] or 0
							local minus_cap = minus[2] or 0
							objvar_value = objvar_value - minus_value
							if(objvar_value < minus_cap) then objvar_value = minus_cap end
							player:SetObjVar(name,objvar_value)
						elseif(value ~= nil) then
							player:SetObjVar(name,value)
						end
					end
				elseif(val.Type=="magicweapon") then
					local template = val.Template or nil
					local template_list = val.TemplateList or nil
					local rank = val.Rank or nil
					local rank_list = val.RankList or nil
					local chance = val.Chance or 1
					local candrop = false
					--TODO: Add Executioner Weapon Stats in the "QuestItemCreated" OnCreate Event
					local executioner_level = val.ExecutionerLevel or nil
					local executioner_type = val.ExecutionerType or nil
					if(chance < 1) then
						if(chance <= math.random()) then
							candrop = true
						end
					else
						candrop = true
					end	
					if(candrop == true) then
						if(template ~= nil) then
							if(rank ~= nil) then
								CreateObjInContainer(template, objRef, GetRandomDropPosition(objRef), "QuestItemCreated", amount,{Type="weapon",Rank=rank,ExecutionerLevel=executioner_level,ExecutionerType=executioner_type})
							elseif(rank_list ~= nil) then
								CreateObjInContainer(template, objRef, GetRandomDropPosition(objRef), "QuestItemCreated", amount,{Type="weapon",RankList=rank_list,ExecutionerLevel=executioner_level,ExecutionerType=executioner_type})
							end
						else					
							local whichtemplate = template_list[math.random(1,#template_list)]
							if(rank ~= nil) then
								CreateObjInContainer(whichtemplate, objRef, GetRandomDropPosition(objRef), "QuestItemCreated", amount,{Type="weapon",Rank=rank})
							elseif(rank_list ~= nil) then
								CreateObjInContainer(whichtemplate, objRef, GetRandomDropPosition(objRef), "QuestItemCreated", amount,{Type="weapon",RankList=rank_list})
							end						
						end
					end
				elseif(val.Type=="magicarmor") then
					local template = val.Template or nil
					local template_list = val.TemplateList or nil
					local rank = val.Rank or nil
					local rank_list = val.RankList or nil
					local chance = val.Chance or 1
					local candrop = false
					if(chance < 1) then
						if(chance <= math.random()) then
							candrop = true
						end
					else
						candrop = true
					end	
					if(candrop == true) then					
						if(template ~= nil) then
							if(rank ~= nil) then
								CreateObjInContainer(template, objRef, GetRandomDropPosition(objRef), "QuestItemCreated", amount,{Type="armor",Rank=rank})
							elseif(rank_list ~= nil) then
								CreateObjInContainer(template, objRef, GetRandomDropPosition(objRef), "QuestItemCreated", amount,{Type="armor",RankList=rank_list})
							end
						else
							local whichtemplate = template_list[math.random(1,#template_list)]
							if(rank ~= nil) then
								CreateObjInContainer(whichtemplate, objRef, GetRandomDropPosition(objRef), "QuestItemCreated", amount,{Type="armor",Rank=rank})
							elseif(rank_list ~= nil) then
								CreateObjInContainer(whichtemplate, objRef, GetRandomDropPosition(objRef), "QuestItemCreated", amount,{Type="armor",RankList=rank_list})
							end						
						end
					end
				elseif(val.Type=="magicoffhand") then
					local template = val.Template or nil
					local template_list = val.TemplateList or nil
					local rank = val.Rank or nil
					local rank_list = val.RankList or nil
					local chance = val.Chance or 1
					local candrop = false
					if(chance < 1) then
						if(chance <= math.random()) then
							candrop = true
						end
					else
						candrop = true
					end	
					if(candrop == true) then					
						if(template ~= nil) then
							if(rank ~= nil) then
								CreateObjInContainer(template, objRef, GetRandomDropPosition(objRef), "QuestItemCreated", amount,{Type="offhand",Rank=rank})
							elseif(rank_list ~= nil) then
								CreateObjInContainer(template, objRef, GetRandomDropPosition(objRef), "QuestItemCreated", amount,{Type="offhand",RankList=rank_list})
							end
						else
							local whichtemplate = template_list[math.random(1,#template_list)]
							if(rank ~= nil) then
								CreateObjInContainer(whichtemplate, objRef, GetRandomDropPosition(objRef), "QuestItemCreated", amount,{Type="offhand",Rank=rank})
							elseif(rank_list ~= nil) then
								CreateObjInContainer(whichtemplate, objRef, GetRandomDropPosition(objRef), "QuestItemCreated", amount,{Type="offhand",RankList=rank_list})
							end						
						end
					end										
				end
			end
		end
	end)

--this fires when a quest reward item is created in the players
--quest reward bag.
RegisterEventHandler(EventType.CreatedObject, "QuestItemCreated", 
	function(success, objref, quantity, params)
		if(type(quantity) == "number") then
			if(success and quantity > 1) then
				RequestSetStack(objref,quantity)	
			end
		end
		if(params ~= nil) then
			if(params.Rank ~= nil) then
				if(params.Type == "weapon") then
					LootTable.Functions.ApplyWeaponProperties(objref,params.Rank)
				elseif(params.Type == "armor") then
					LootTable.Functions.ApplyArmorProperties(objref,params.Rank)
				elseif(params.Type == "offhand") then
					LootTable.Functions.ApplyOffHandProperties(objref,params.Rank)
				end
			elseif(params.RankList ~= nil) then
				local paramlist = params.RankList or {"RankOne"}
				local whichrank = paramlist[math.random(1,#paramlist)]
				if(params.Type == "weapon") then
					LootTable.Functions.ApplyWeaponProperties(objref,whichrank)
				elseif(params.Type == "armor") then
					LootTable.Functions.ApplyArmorProperties(objref,whichrank)
				elseif(params.Type == "offhand") then
					LootTable.Functions.ApplyOffHandProperties(objref,whichrank)
				end
			end
			CallFunctionDelayed(TimeSpan.FromMilliseconds(100),function() LootTable.Functions.UpdateItemTooltip(objref) end)
		end
		SetItemTooltip(objref)			
	end)

--this is the handler for the npc interface for the quest intro dialog
RegisterEventHandler(EventType.DynamicWindowResponse,"QuestIntroDialog", 
	function (user,buttonId)
		local info = StringSplit(buttonId,":")
		local button = info[1]
		local param = info[2] or nil
		local style = this:GetObjVar("Quests_WindowStyle")
		local questlog = user:GetObjVar("Quests_QuestLog") or nil

		if(button == "ViewQuest") then
			if(param ~= nil) then
				if(questlog ~= nil) then
					if(CustomQuests.Helpers.IsQuestComplete(user,param)) then
						ShowQuestFinishDialog(user,this,param,style)
						return
					end
					if(CustomQuests.Helpers.CanGetQuest(user,this,param)) then
						ShowQuestDialog(user,this,param,style)
					else
						user:SystemMessage("[FFAA00]you may not aquire this quest at this time.")
					end
				end
			end
		end
		if(button == "AcceptQuest") then
			if(param ~= nil) then
				--table.insert(questlog,param)
				--user:SetObjVar("Quests_QuestLog",questlog)
				CustomQuests.Helpers.GiveQuest(user,param)
				user:SystemMessage("You have acquired the \"".. CustomQuests.Quests[param].Title .. "\" quest")					
				user:SystemMessage((user:GetObjVar("Quests_QuestLog")[1]))
			end
		end
		if(button == "DeclineQuest") then
			user:SystemMessage("You decided to decline the qeust offer.")
			ShowIntroWindow(user, this, style)
		end
		if(button == "CompleteQuest") then
			local completeMessage = 
			{
				"thank you "..user:GetName().. " for helping me.",
				"there is no one braver then " .. user:GetName(),
				"all hail " .. user:GetName()..", a true protector of the lands",
				"excellent job " .. user:GetName().." our lives are better because of you",
				"outstanding, someone needs to buy " ..user:GetName().. " an round of drinks",
			}
			this:NpcSpeech(completeMessage[math.random(#completeMessage)])
			if(CustomQuests.Quests[param].Delay ~= nil)then
				local questDelayTime = {}
				if(user:HasObjVar("Quests_DelayTime") == true) then
					if(CustomQuests.Quests[param].Delay < 0) then
						questDelayTime = user:GetObjVar("Quests_DelayTime")
						questDelayTime[param] = {NextTime=-1}
						user:SetObjVar("Quests_DelayTime",questDelayTime)						
					else
						questDelayTime = user:GetObjVar("Quests_DelayTime")
						questDelayTime[param] = {NextTime=(os.time()+CustomQuests.Quests[param].Delay)}
						user:SetObjVar("Quests_DelayTime",questDelayTime)
					end
				else
					if(CustomQuests.Quests[param].Delay < 0) then
						questDelayTime[param] = {NextTime=-1}
						user:SetObjVar("Quests_DelayTime",questDelayTime)
					else
						questDelayTime[param] = {NextTime=(os.time()+CustomQuests.Quests[param].Delay)}
						user:SetObjVar("Quests_DelayTime",questDelayTime)
					end					
				end
			end
			CustomQuests.Helpers.RemoveQuest(user,param)
			RewardPlayer(user,param)
			user:SystemMessage("Great Work!! You completed the [FF7700]"..CustomQuests.Quests[param].Title .. " [FFFFFF]quest." )
			user:PlayObjectSound("QuestComplete")
			user:PlayEffect("ResurrectEffect",3)
			user:PlayEffect("CastAir2",3)
			user:PlayEffect("CastFire2",3)
			user:PlayEffect("CastWater2",3)
			user:PlayAnimation("fistpump")
			this:PlayAnimation("wave")
		end
		if(button=="OpenCustomWindow") then
			ShowCustomWindow(user)
		end
		if(button=="ToggleDressMode") then
			local mode = this:GetObjVar("DressMode")
			mode = not mode
			this:SetObjVar("DressMode",mode)
			CallFunctionDelayed(TimeSpan.FromMilliseconds(1000),function ( ... ) ShowIntroWindow(user, this ,style) end)	
		end
	end)

--this is the NPC Customizewindow event handler mmmm
RegisterEventHandler(EventType.DynamicWindowResponse, "QuestNpcCustomWindow",
	function (user,buttonId)
		if (IsMale(this)) then
			GenderBodyTable = QuestGiverCustomization.BodyTypesMale
			GenderHairTable = QuestGiverCustomization.HairTypesMale
		end

		if (IsFemale(this)) then
			GenderBodyTable = QuestGiverCustomization.BodyTypesFemale
			GenderHairTable = QuestGiverCustomization.HairTypesFemale
		end

		if (GenderHairTable == nil or GenderBodyTable == nil) then
			DebugMessage("[custom_char_window|QuestNpcCustomWindow] ERROR: Player has unsupported gender/body type.")
			return
		end

		if (buttonId == "FullBody") then
			FullBody = not FullBody
			ShowCustomWindow(user)
		end

		if (buttonId == "BodyLeft") then
			SelectedBodyType = SelectedBodyType - 1--deincrement by one
			--change the body type
			if (SelectedBodyType > #GenderBodyTable) then SelectedBodyType = 1 end--if over the length set to 1
			if (SelectedBodyType < 1) then SelectedBodyType = #GenderBodyTable end--if less than 1 then set to length
			local currentEquipped = this:GetEquippedObject("BodyPartHead")
			--DebugMessage("currentEquipped is "..tostring(currentEquipped))
			if (currentEquipped ~= nil) then
				currentEquipped:Destroy()
			end
			--create the new body type
			if (GenderBodyTable[SelectedBodyType].Template ~= nil) then
				CreateEquippedObj(GenderBodyTable[SelectedBodyType].Template, this, "created_body_type")--set the equipped object to the template in the index
			end
			--this:PlayEffect("TeleportToEffect")
			--reopen the character window
			ShowCustomWindow(user)
		elseif (buttonId == "BodyRight") then
			SelectedBodyType = SelectedBodyType + 1--increment by one
			--change the body type
			if (SelectedBodyType > #GenderBodyTable) then SelectedBodyType = 1 end--if over the length set to 1
			if (SelectedBodyType < 1) then SelectedBodyType = #GenderBodyTable end--if less than 1 then set to length
			local currentEquipped = this:GetEquippedObject("BodyPartHead")
			--DebugMessage("currentEquipped is "..tostring(currentEquipped))
			if (currentEquipped ~= nil) then
				currentEquipped:Destroy()
			end
			--create the new body type
			if (GenderBodyTable[SelectedBodyType].Template ~= nil) then
				CreateEquippedObj(GenderBodyTable[SelectedBodyType].Template, this, "created_body_type")--set the equipped object to the template in the index
			end
			--reopen the character window
			--this:PlayEffect("TeleportToEffect")
			ShowCustomWindow(user)
		elseif (buttonId == "HairLeft") then
			SelectedHairType = SelectedHairType - 1--deincrement by one
			--change the hair type
			if (SelectedHairType > #GenderHairTable) then SelectedHairType = 1 end--if over the length set to 1
			if (SelectedHairType < 1) then SelectedHairType = #GenderHairTable end--if less than 1 then set to length
			local currentEquipped = this:GetEquippedObject("BodyPartHair")
			if (currentEquipped ~= nil) then
				currentEquipped:Destroy()
			end
			--create the new hair type
			if (GenderHairTable[SelectedHairType].Template ~= nil) then
				CreateEquippedObj(GenderHairTable[SelectedHairType].Template, this, "CreatedHair")--set the equipped object to the template in the index
			end
			--reopen the character window
			--this:PlayEffect("TeleportToEffect")
			ShowCustomWindow(user)
		elseif (buttonId == "HairRight") then
			SelectedHairType = SelectedHairType + 1--increment by one
			--change the hair type
			if (SelectedHairType > #GenderHairTable) then SelectedHairType = 1 end--if over the length set to 1
			if (SelectedHairType < 1) then SelectedHairType = #GenderHairTable end--if less than 1 then set to length
			local currentEquipped = this:GetEquippedObject("BodyPartHair")
			if (currentEquipped ~= nil) then
				currentEquipped:Destroy()
			end
			--create the new hair type
			if (GenderHairTable[SelectedHairType].Template ~= nil) then
				CreateEquippedObj(GenderHairTable[SelectedHairType].Template, this, "CreatedHair")--set the equipped object to the template in the index
			end
			--this:PlayEffect("TeleportToEffect")
			ShowCustomWindow(user)
			--reopen the character window
		elseif (buttonId == "HairColorLeft") then
			SelectedHairColorType = SelectedHairColorType - 1--deincrement by one
			--change the hair color
			if (SelectedHairColorType > #QuestGiverCustomization.HairColorTypes) then SelectedHairColorType = 1 end--if over the length set to 1
			if (SelectedHairColorType < 1) then SelectedHairColorType = #QuestGiverCustomization.HairColorTypes end--if less than 1 then set to length

			local currentEquipped = this:GetEquippedObject("BodyPartHair")
			if (currentEquipped ~= nil) then
				currentEquipped:Destroy()
			end
			
			if (GenderHairTable[SelectedHairType].Template ~= nil) then
				CreateEquippedObj(GenderHairTable[SelectedHairType].Template, this, "CreatedHair")--set the equipped object to the template in the index
			end
			--reopen the character window
			--this:PlayEffect("TeleportToEffect")
			ShowCustomWindow(user)
		elseif (buttonId == "HairColorRight") then
			SelectedHairColorType = SelectedHairColorType + 1--increment by one
			--change the hair color
			if (SelectedHairColorType > #QuestGiverCustomization.HairColorTypes) then SelectedHairColorType = 1 end--if over the length set to 1
			if (SelectedHairColorType < 1) then SelectedHairColorType = #QuestGiverCustomization.HairColorTypes end--if less than 1 then set to length

			local currentEquipped = this:GetEquippedObject("BodyPartHair")
			if (currentEquipped ~= nil) then
				currentEquipped:Destroy()
			end
			
			if (GenderHairTable[SelectedHairType].Template ~= nil) then
				CreateEquippedObj(GenderHairTable[SelectedHairType].Template, this, "CreatedHair")--set the equipped object to the template in the index
			end
			--reopen the character window
			--this:PlayEffect("TeleportToEffect")
			ShowCustomWindow(user)
		elseif (buttonId == "ChangeApperance" or buttonId == "") then
			--just close the window
			this:CloseDynamicWindow("charCustomWindow")
			
			this:SendMessage("ClosedCustomCharWindow")
		end
	end)

--when this npc is feeling used, this event fires
RegisterEventHandler(EventType.Message, "UseObject", 
	function(user,usedType)
		if(CustomQuests.Enabled) then
			if(this:DistanceFrom(user) <= 5) then
				local style = this:GetObjVar("Quests_WindowStyle")
				if(usedType=="Quests") then
					ShowIntroWindow(user, this, style)
				end
				GetAttention(user)
				this:PlayAnimation("Wave")
				user:SetFacing(user:GetLoc():YAngleTo(this:GetLoc()))
			else
				user:SystemMessage("you must be closer to interact with "..this:GetName())
			end
		end
	end)

--when the module attaches to tne npc, need to set up a few variables
RegisterSingleEventHandler(EventType.ModuleAttached, GetCurrentModule(), 
	function()
		if(CustomQuests.Enabled) then
			this:SetObjVar("DressMode",true)
			this:SetSharedObjectProperty("Title", "[ABAB35]-|Quest Giver|-")
			AddUseCase(this,"Quests",CustomQuests.IsDefaultUseCase)
		end
	end)










