-- written by Gizmo
----------------------------------------------------------------------
-- If you like Project Phoenix and want to help support the project
-- you could send any donation amount to jessebutler1975@gmail.com at
-- paypal.com
--
-- Thank you for using my product, 
-- I hope you enjoy it as much as I do
----------------------------------------------------------------------
----------------------------------------------------------
--			HandleEquipmentItem(equipmentItemTable)
----------------------------------------------------------
--if the items are hued on the merchant lets keep it that 
--way
function HandleEquipmentItem(equipmentItemTable)
	local template = equipmentItemTable[1]
	local hue = equipmentItemTable[2] or 0
	local color = equipmentItemTable[3] or "FFFFFF" 
	CreateEquippedObj(template, this, "equipItemCreated", hue, color)
end

----------------------------------------------------------
-- EVENTTYPE - EventType.CreatedObject			
----------------------------------------------------------
RegisterEventHandler(EventType.CreatedObject,"equipItemCreated",
	function(success,objRef,hue,color)
		if(objRef ~= nil) then
			objRef:SetColor(color)
			objRef:SetHue(hue)
		end
	end)

-----------------------------------------------------------------------------------
--								      Initializer 
-----------------------------------------------------------------------------------

RegisterSingleEventHandler(EventType.ModuleAttached, GetCurrentModule(), 
	function()
		if(CustomQuests.Enabled) then
			if(initializer ~= nil) then
				local ListToOfferPlayer = {}
				if(initializer.QuestsToOffer ~= nil) then
					ListToOfferPlayer = initializer.QuestsToOffer
					this:SetObjVar("Quests_ListToOfferPlayer",ListToOfferPlayer)
				end
			end
		end
		if(initializer.Equipment ~= nil) then
			for index, equipmentItemTable in pairs(initializer.Equipment) do
				HandleEquipmentItem(equipmentItemTable)
			end
		end
	end)
