-- written by Gizmo
----------------------------------------------------------------------
-- If you like Project Phoenix and want to help support the project
-- you could send any donation amount to jessebutler1975@gmail.com at
-- paypal.com
--
-- Thank you for using my product, 
-- I hope you enjoy it as much as I do
----------------------------------------------------------------------
-----------------------------------------------------------------------------------
--						  Global Quest Helper Functions							  
-----------------------------------------------------------------------------------

CustomQuests.Helpers = 
{
	AddSlayTask = function(template,amount,objvarneeded,killname)
		if(objvarneeded == nil) then objvarneeded = "" end
		return {"slay",template,amount,0,objvarneeded,killname}
	end,

	AddHarvestTask = function(template,amount,objvarneeded,collectname)
		if(objvarneeded == nil) then objvarneeded = "" end
		return {"harvest",template,amount,0,objvarneeded,collectname}
	end,

	AddCraftTask = function(template,amount,resourceneeded,collectname)
		if(objvarneeded == nil) then objvarneeded = "" end
		return {"craft",template,amount,0,resourceneeded,collectname}
	end,

	AddTameTask = function(template,amount,objvarneeded,collectname)
		if(objvarneeded == nil) then objvarneeded = "" end
		return {"tame",template,amount,0,objvarneeded,collectname}
	end,

	CanGetQuest = function(player,questgiver,questname)
		local quest_log = player:GetObjVar("Quests_QuestLog") or {}
		local quest_list = questgiver:GetObjVar("Quests_ListToOfferPlayer") or {}
		for t,valt in pairs(quest_list) do
			if(quest_log[questname] ~= nil) then
				if(quest_log[questname].Title == CustomQuests.Quests[questname].Title) then
					return false 
				end
			end
		end
		return true
	end,

	HasQuest = function(player,questname)
		local quest_log = player:GetObjVar("Quests_QuestLog") or {}
		for i,val in pairs(quest_log) do
			if not(val.Quest == nil) then
				if(val.Quest == questname) then return true end
			end
		end
		return false
	end,

	GiveQuest = function(player,quest)
		quest_log = player:GetObjVar("Quests_QuestLog")
		quest_tasks = CustomQuests.Quests[quest].Tasks
		for i,val in pairs(quest_tasks) do
			val["IsComplete"] = false
		end
		quest_log[quest] = {
			Quest = quest,
			Title = CustomQuests.Quests[quest].Title,
			IsComplete = false,
			Tasks = quest_tasks,
		}

		player:SetObjVar("Quests_QuestLog",quest_log)
	end,

	RemoveQuest = function(player,quest)
		quest_log = player:GetObjVar("Quests_QuestLog")
		for i,val in pairs(quest_log) do
			if(i == quest) then
				quest_log[quest] = nil
				player:SetObjVar("Quests_QuestLog",quest_log)
			end
		end
	end,

	--this function needs fixed
	--it cycles through all the quests you have and counts the objectives of all
	--just need to count the objective of the single quest.
	IsQuestComplete = function(player,quest)
		quest_log = player:GetObjVar("Quests_QuestLog")
		for i,vali in pairs(quest_log) do
			if(quest==vali.Quest) then
				local count = 0
				local totaltasks = 0
				for t,valt in pairs(vali.Tasks) do
					totaltasks = totaltasks + 1
				 	if (valt.IsComplete) then 
						count = count + 1
				 	end
				end
				if(count >= totaltasks and count ~= 0)then return true end
			end
		end
		
		return false			
	end,

	CheckQuestObjectives = function(player,object)
		--for harvest system update
		if(type(object) == "string") then
			object_template = object
		else
			object_template = object:GetCreationTemplateId()
		end
		--local complete_counter = 0
		quest_log = player:GetObjVar("Quests_QuestLog")
		if(object_template == nil or quest_log == nil) then return end
		for i,vali in pairs(quest_log) do
			for t,valt in pairs(vali.Tasks) do
				if(valt[1]=="slay" and not valt.IsComplete) then
					if(valt[2] == object_template) then
						if(valt[5] ~= "") then
							if(object:HasObjVar(valt[5]) == false) then return end
						end
						valt[4] = valt[4] + 1
						player:SystemMessage(valt[4].."/"..valt[3].." "..StripColorFromString(object:GetName()).." slain","info")
						if(valt[3]==valt[4]) then
							valt.IsComplete = true
						end
						table.remove(quest_log[vali.Quest].Tasks,tonumber(t))
						table.insert(quest_log[vali.Quest].Tasks,tonumber(t),valt)
						player:SetObjVar("Quests_QuestLog",quest_log)
					end
				elseif(valt[1]=="harvest" and not valt.IsComplete) then
					if(valt[2] == object_template) then
						if(valt[5] ~= "") then
							if(object:HasObjVar(valt[5]) == false) then return end
						end							
 						valt[4] = valt[4] + 1
						player:SystemMessage(valt[4].."/"..valt[3].." harvested","info")
						if(valt[3]==valt[4]) then
							valt.IsComplete = true
						end
						table.remove(quest_log[vali.Quest].Tasks,tonumber(t))
						table.insert(quest_log[vali.Quest].Tasks,tonumber(t),valt)
						player:SetObjVar("Quests_QuestLog",quest_log)
					end
				elseif(valt[1]=="tame" and not valt.IsComplete) then	
					if(valt[2] == object_template) then
						if(valt[5] ~= "") then
							if(object:HasObjVar(valt[5]) == false) then return end
						end							
 						valt[4] = valt[4] + 1
						player:SystemMessage(valt[4].."/"..valt[3].." "..StripColorFromString(object:GetName()).." tamed","info")
						if(valt[3]==valt[4]) then
							valt.IsComplete = true
						end
						table.remove(quest_log[vali.Quest].Tasks,tonumber(t))
						table.insert(quest_log[vali.Quest].Tasks,tonumber(t),valt)
						player:SetObjVar("Quests_QuestLog",quest_log)
					end
				elseif(valt[1]=="craft" and not valt.IsComplete) then
						if(valt[5] ~= "") then
							if not(object:GetObjVar("Material")==valt[5]) then return false end
						end		
					if(valt[2] == object_template) then
 						valt[4] = valt[4] + 1
						player:SystemMessage(valt[4].."/"..valt[3].." "..StripColorFromString(object:GetName()).." crafted","info")
						if(valt[3]==valt[4]) then
							valt.IsComplete = true
						end
						table.remove(quest_log[vali.Quest].Tasks,tonumber(t))
						table.insert(quest_log[vali.Quest].Tasks,tonumber(t),valt)
						player:SetObjVar("Quests_QuestLog",quest_log)
					end						
			    end				    
			end			
		end
	end,

	CheckDelay = function(player,quest)
		if(player:HasObjVar("Quests_DelayTime") == true) then
			local questDelayTime = player:GetObjVar("Quests_DelayTime")
			for k,v in pairs(questDelayTime) do
				if(k == quest) then
					if (v["NextTime"] == -1) then
						player:SystemMessage("[BBBB44]you may acquire the quest [FF7700]"..CustomQuests.Quests[k].Title.."[BBBB44] again.")
						return false
					end
					if not(os.time()>=v["NextTime"]) then
						player:SystemMessage("[BBBB44]you must wait a while to do the quest [FF7700]"..CustomQuests.Quests[k].Title.."[BBBB44] again.")
						return false
					end
				end
			end				
		end

		return true	
	end,
}



