-- written by Gizmo
----------------------------------------------------------------------
-- If you like Project Phoenix and want to help support the project
-- you could send any donation amount to jessebutler1975@gmail.com at
-- paypal.com
--
-- Thank you for using my product, 
-- I hope you enjoy it as much as I do
----------------------------------------------------------------------
CustomQuests.Quests = 
{
	--------------------------------------------------------------------------------------------	
	--								  Eldier Village Quests
	--------------------------------------------------------------------------------------------	
	EldierVillage_Graveyard_Shift =
	{
		Title = "Graveyard Shift",
		Description = "I need you to go clean up the graveyard to the north of us, take care of 3 zombies and 3 skeletons and put them back to rest.",
		QuestCompletedMessage = "Captain Ezekio will be pleased by your efforts to help keep Eldeir safe for the people.",
		Delay = 300,
		Tasks =
		{  
			CustomQuests.Helpers.AddSlayTask("skeleton",3,"graveyard_shift","Skeleton"),
			CustomQuests.Helpers.AddSlayTask("zombie",3,"graveyard_shift","Zombie"),
		},
		Rewards =
		{
			{Type="faction", Faction="Eldeir Village", Value=5, Cap=100},
			{Type="coins", MinAmount = 75, MaxAmount = 125,},
		},
		Requirements =
		{
			Check = function(player,quest_npc,quest)
				if not(CustomQuests.Helpers.CheckDelay(player,quest)) then return false end
				return true
			end,
		},		
	},
	EldierVillage_Resource_Gathering_Plants =
	{
		Title = "Resource Gathering: Plants",
		Description = "All around town you can find wild herbs growing. I would like to study these more if you can help me with a small task. Ill pay.",
		QuestCompletedMessage = "These are not really the quality I am looking for. To not waste your time, here is a small payment.",
		Delay = 600,
		Tasks =
		{  
			CustomQuests.Helpers.AddHarvestTask("plant_ginseng",3,"eldeir_village_plant","Ginseng"),
			CustomQuests.Helpers.AddHarvestTask("plant_mushrooms",3,"eldeir_village_plant","Mushroom"),
			CustomQuests.Helpers.AddHarvestTask("plant_lemon_grass",3,"eldeir_village_plant","Lemon Grass"),
			CustomQuests.Helpers.AddHarvestTask("plant_moss",3,"eldeir_village_plant","Moss"),
		},
		Rewards =
		{
			{Type="faction", Faction="Eldeir Village", Value=5, Cap=100},
			{Type="coins", MinAmount = 75, MaxAmount = 125,},
			{Type="item", Template="ingredient_moss", Amount=10, Chance=0.55,},
			{Type="item", Template="ingredient_lemongrass", Amount=10, Chance=0.75,},
			{Type="item", Template="ingredient_mushroom", Amount=10, Chance=0.55,},
			{Type="item", Template="ingredient_ginsengroot", Amount=10, Chance=0.75,},
			{Type="item", Template="trade_bar", Amount=1, Chance=1,},
		},
		Requirements =
		{
			Check = function(player,quest_npc,quest)
				if not(CustomQuests.Helpers.CheckDelay(player,quest)) then return false end
				return true
			end,
		},
	},	
	EldierVillage_Resource_Gathering_Mining =
	{
		Title = "Resource Gathering: Mining",
		Description = "All around the village we have many resources to harvest. If you are looking to become an apprentice, then someone has to teach you.",
		QuestCompletedMessage = "Good work, nothing makes you feel stronger then waking up the next day after hauling ore and stone. Here is your earnings.",
		Delay = 600,
		Tasks =
		{  
			CustomQuests.Helpers.AddHarvestTask("resource_stone",20,"","Stone"),
			CustomQuests.Helpers.AddHarvestTask("resource_iron_ore",10,"","Iron Ore"),
		},
		Rewards =
		{
			{Type="faction", Faction="Eldeir Village", Value=5, Cap=100},
			{Type="coins", MinAmount = 75, MaxAmount = 125,},
			{Type="item", Template="resource_iron", Amount=10, Chance=1,},
			{Type="item", Template="trade_bar", Amount=1, Chance=1,},
		},
		Requirements =
		{
			Check = function(player,quest_npc,quest)
				if not(CustomQuests.Helpers.CheckDelay(player,quest)) then return false end
				return true
			end,
		},					
	},			
	EldierVillage_Resource_Gathering_Lumberjacking =
	{
		Title = "Resource Gathering: Lumberjacking",
		Description = "So your wanting to learn a bit about lumberjacking eh? Not a problem just simply pick up a hatchet and start chopping. Practice Some.",
		QuestCompletedMessage = "Fine Fine Job, come back later for some more training. Here is something for your efforts today.",
		Delay = 600,
		Tasks =
		{  
			CustomQuests.Helpers.AddHarvestTask("resource_wood",30,"","Wood"),
		},
		Rewards =
		{
			{Type="faction", Faction="Eldeir Village", Value=5, Cap=100},
			{Type="coins", MinAmount = 75, MaxAmount = 125,},
			{Type="item", Template="resource_wood", Amount=10, Chance=1,},
			{Type="item", Template="trade_bar", Amount=1, Chance=1,},
		},
		Requirements =
		{
			Check = function(player,quest_npc,quest)
				if not(CustomQuests.Helpers.CheckDelay(player,quest)) then return false end
				return true
			end,
		},					
	},	
	EldierVillage_Resource_Gathering_Cotton =
	{
		Title = "Resource Gathering: Cotton",
		Description = "If you would be a dear and go harvest some cotton from my field, that would be great. Oh yeah, I will pay you for your time.",
		QuestCompletedMessage = "These where picked kinda early, didn't you see any bigger ones? Oh bother... Just keep them, here take this for your troubles.",
		Delay = 600,
		Tasks =
		{  
			CustomQuests.Helpers.AddHarvestTask("plant_cotton",15,"eldeir_village_cotton","Cotton"),
		},
		Rewards =
		{
			{Type="faction", Faction="Eldeir Village", Value=5, Cap=100},
			{Type="coins", MinAmount = 75, MaxAmount = 125,},
			{Type="item", Template="resource_cotton", Amount=10, Chance=1,},
			{Type="item", Template="trade_bar", Amount=1, Chance=1,},
		},
		Requirements =
		{
			Check = function(player,quest_npc,quest)
				if not(CustomQuests.Helpers.CheckDelay(player,quest)) then return false end
				return true
			end,
		},
	},
	EldierVillage_Resource_Gathering_Skinning =
	{
		Title = "Resource Gathering: Skinning",
		Description = "Go out and harvest me some good quality leather. If I am impressed enough with your work, I might even pay ya. What do you say?",
		QuestCompletedMessage = "Well, I think I have seen better quality but this isn't bad for a new hire. Come back later and show me your work. Here is your wage I promised.",
		Delay = 600,
		Tasks =
		{  
			CustomQuests.Helpers.AddHarvestTask("animalparts_leather_hide",20,"","Leather"),
		},
		Rewards =
		{
			{Type="faction", Faction="Eldeir Village", Value=5, Cap=100},
			{Type="coins", MinAmount = 75, MaxAmount = 125,},
			{Type="item", Template="resource_leather", Amount=10, Chance=1,},
			{Type="item", Template="trade_bar", Amount=1, Chance=1,},
		},
		Requirements =
		{
			Check = function(player,quest_npc,quest)
				if not(CustomQuests.Helpers.CheckDelay(player,quest)) then return false end
				return true
			end,
		},
	},
	EldierVillage_Resource_Gathering_Fishing =
	{
		Title = "Resource Gathering: Fishing",
		Description = "Nothing beats the times one can go out and cash a handfull of them delicious tero fish oh.... and some barrel fish too. Its a good fish to practice, easy to catch. Why don't you show me what you got and catch a dozen..Sound Good?",
		QuestCompletedMessage = "These are not very big at all, come back later and I will teach you some more.",
		Delay = 600,
		Tasks =
		{  
			CustomQuests.Helpers.AddHarvestTask("resource_fish_tero",6,"","Tero Fish"),
			CustomQuests.Helpers.AddHarvestTask("resource_fish_barrel",6,"","Barrel Fish"),
		},
		Rewards =
		{
			{Type="faction", Faction="Eldeir Village", Value=5, Cap=100},
			{Type="coins", MinAmount = 75, MaxAmount = 125,},
			{Type="item", Template="resource_fish_tero", Amount=12, Chance=1,},
			{Type="item", Template="resource_fish_barrel", Amount=12, Chance=1,},
			{Type="item", Template="trade_bar", Amount=1, Chance=1,},
		},
		Requirements =
		{
			Check = function(player,quest_npc,quest)
				if not(CustomQuests.Helpers.CheckDelay(player,quest)) then return false end
				return true
			end,
		},
	},
	
	
	EldierVillage_Crafting_Blacksmithing_15_30 =
	{
		Title = "Weapon Smithing I: Daggers",
		Description = "So you want to learn the art of weapon smithing, well judging by your skill that I have seen, why dont you practice on some iron daggers.",
		QuestCompletedMessage = "These are not so shabby, but could use more practice on for sure. Come back in a bit and I will show you more.",
		Delay = 600,
		Tasks =
		{  
			CustomQuests.Helpers.AddCraftTask("weapon_dagger",1,"Iron","Iron Dagger"),
		},
		Rewards =
		{
			{Type="magicweapon", Template="weapon_dagger", Rank="RankOne",Chance=0.5,},
			{Type="magicweapon", Template="weapon_dagger", Rank="RankOne",},
			{Type="magicweapon", Template="weapon_dagger", Rank="RankOne",},
			{Type="magicweapon", Template="weapon_dagger", Rank="RankOne",Chance=0.5,},
			-- {Type="magicweapon", Template="weapon_mace", RankList={"RankOne","RankTwo"},},
			-- {Type="magicweapon", TemplateList={"weapon_saber","weapon_largeaxe"}, Rank="RankOne",},
			-- {Type="magicweapon", TemplateList={"weapon_shortbow","weapon_longsword",}, RankList={"RankTwo","RankThree","RankFour"},},
			{Type="faction", Faction="Eldeir Village", Value=5, Cap=100},
			{Type="coins", MinAmount = 75, MaxAmount = 125,},
			{Type="item", Template="resource_iron", Amount=10, Chance=1,},
			{Type="item", Template="trade_bar", Amount=1, Chance=1,},
		},
		Requirements =
		{
			Check = function(player,quest_npc,quest)
				if not(CustomQuests.Helpers.CheckDelay(player,quest)) then return false end
				if (CustomQuests.Helpers.IsQuestComplete(player,quest) == true) then return true end
				if not(GetSkillLevel(player,"MetalsmithSkill") > 14.9 and GetSkillLevel(player,"MetalsmithSkill") < 30.1) then 
					return false
				end
				return true
			end,
		},
	},											
	EldierVillage_Crafting_Blacksmithing_30_45 =
	{
		Title = "Weapon Smithing II: Longswords",
		Description = "So you want to learn the art of weapon smithing, well judging by your skill that I have seen, why dont you practice on some iron longswords.",
		QuestCompletedMessage = "These are not so shabby, but could use more practice on for sure. Come back in a bit and I will show you more.",
		Delay = 600,
		Tasks =
		{  
			CustomQuests.Helpers.AddCraftTask("weapon_longsword",10,"Iron","Iron Longsword"),
		},
		Rewards =
		{
			{Type="faction", Faction="Eldeir Village", Value=5, Cap=500},
			{Type="coins", MinAmount = 125, MaxAmount = 175,},
			{Type="item", Template="resource_iron", Amount=15, Chance=1,},
			{Type="item", Template="trade_bar", Amount=1, Chance=1,},
		},
		Requirements =
		{
			Check = function(player,quest_npc,quest)
				if not(CustomQuests.Helpers.CheckDelay(player,quest)) then return false end
				if (CustomQuests.Helpers.IsQuestComplete(player,quest) == true) then return true end
				if not(GetSkillLevel(player,"MetalsmithSkill") > 29.9 and GetSkillLevel(player,"MetalsmithSkill") < 45.1) then 
					return false
				end
				return true
			end,
		},
	},											
	EldierVillage_Crafting_Blacksmithing_45_65 =
	{
		Title = "Weapon Smithing III: Broadswords",
		Description = "So you want to learn the art of weapon smithing, well judging by your skill that I have seen, why dont you practice on some iron broadswords.",
		QuestCompletedMessage = "These are not so shabby, but could use more practice on for sure. Come back in a bit and I will show you more.",
		Delay = 600,
		Tasks =
		{  
			CustomQuests.Helpers.AddCraftTask("weapon_broadsword",10,"Iron","Iron Broadsword"),
		},
		Rewards =
		{
			{Type="faction", Faction="Eldeir Village", Value=5, Cap=5000},
			{Type="coins", MinAmount = 225, MaxAmount = 275,},
			{Type="item", Template="resource_iron", Amount=25, Chance=1,},
			{Type="item", Template="trade_bar", Amount=1, Chance=1,},
		},
		Requirements =
		{
			Check = function(player,quest_npc,quest)
				if not(CustomQuests.Helpers.CheckDelay(player,quest)) then return false end
				if (CustomQuests.Helpers.IsQuestComplete(player,quest) == true) then return true end
				if not(GetSkillLevel(player,"MetalsmithSkill") > 44.9 and GetSkillLevel(player,"MetalsmithSkill") < 65.1) then 
					return false
				end
				return true
			end,
		},
	},
	EldierVillage_Crafting_Blacksmithing_65_80 =
	{
		Title = "Weapon Smithing IV: Sabers",
		Description = "So you want to learn the art of weapon smithing, well judging by your skill that I have seen, why dont you practice on some iron sabers.",
		QuestCompletedMessage = "These are not so shabby, but could use more practice on for sure. Come back in a bit and I will show you more.",
		Delay = 600,
		Tasks =
		{  
			CustomQuests.Helpers.AddCraftTask("weapon_saber",10,"Iron","Iron Saber"),
		},
		Rewards =
		{
			{Type="faction", Faction="Eldeir Village", Value=5, Cap=5000},
			{Type="coins", MinAmount = 325, MaxAmount = 375,},
			{Type="item", Template="resource_iron", Amount=20, Chance=1,},
			{Type="item", Template="resource_copper", Amount=10, Chance=1,},
			{Type="item", Template="trade_bar", Amount=1, Chance=1,},
		},
		Requirements =
		{
			Check = function(player,quest_npc,quest)
				if not(CustomQuests.Helpers.CheckDelay(player,quest)) then return false end
				if (CustomQuests.Helpers.IsQuestComplete(player,quest) == true) then return true end
				if not(GetSkillLevel(player,"MetalsmithSkill") > 64.9 and GetSkillLevel(player,"MetalsmithSkill") < 80.1) then 
					return false
				end
				return true
			end,
		},
	},											
	--------------------------------------------------------------------------------------------	
	--								  ENTER CUSTOM QUESTS BELOW
	--------------------------------------------------------------------------------------------	
	ExampleQuest =
	{
		Title = "Example Quest",
		Description = "This is a example quest",
		QuestCompletedMessage = "you completed the example quest, good job",
		Delay = 30,
		Tasks =
		{  
			--CustomQuests.Helpers.AddCraftTask("weapon_dagger",1,"example_quest_objvar","Dagger"),
			CustomQuests.Helpers.AddTameTask("black_bear",1,"example_quest_objvar","Black Bear"),
			--CustomQuests.Helpers.AddHarvestTask("plant_cotton",1,"example_quest_objvar","Cotton Plant"),
			--CustomQuests.Helpers.AddSlayTask("skeleton",1,"example_quest_objvar","Bone Warrior"),
		},
		Rewards =
		{
			--{Type="coins", MinAmount = 125, MaxAmount = 200,},
			--{Type="faction", Faction="Halland", Value=10, Cap=250},
			{Type="item", Template="weapon_dagger", Amount=1, Chance=0.5,},
			{Type="coins", MinAmount = 75, MaxAmount = 125,},
			--{Type="objvar", Name="EldierVillage.Reputation", Plus = {5,250},},
			--{Type="objvar", Name="Valus.Reputation", Minus = {10,-250},},						
		},
		Requirements =
		{
			Check = function(player,quest_npc,quest)
				if not(CustomQuests.Helpers.CheckDelay(player,quest)) then return false end
				return true
			end,
		},		
	},


	--The below table is a blank quest table template to copy + paste to create your new quest.
	--start copy below
	--=====================================================================================================
	--Global Variable Name for quest
	EmptyQuest =
	{
		--Title of the quest
		Title = "Empty Quest",
		--Description of the taks the npc wants you to do.
		Description = "",
		--The message you get from the npc when you complete the quest
		QuestCompletedMessage = "",
		--The Delay in seconds until the player can pick the quest up again 600 = 10 minutes
		Delay = 600,
		--A list of tasks the player need to complete (MAX 4) due to current UI limitations
		Tasks =
		{  
			--CustomQuests.Helpers.AddCraftTask("weapon_dagger",1,"Copper","Dagger"),
			--CustomQuests.Helpers.AddTameTask("black_bear",1,"example_quest_objvar","Black Bear"),
			--CustomQuests.Helpers.AddHarvestTask("plant_cotton",1,"example_quest_objvar","Cotton Plant"),
			--CustomQuests.Helpers.AddSlayTask("skeleton",1,"example_quest_objvar","Bone Warrior"),
		},
		--A list of rewards the player earns in their quest bag when completing the quest
		Rewards =
		{
			--{Type="coins", MinAmount = 125, MaxAmount = 200,},
			--{Type="faction", Faction="Halland", Value=10, Cap=250},
			--{Type="item", Template="weapon_dagger", Amount=1, Chance=0.5,},
			--{Type="magicweapon", Template="weapon_dagger", Rank="RankOne", Chance=0.5},			
		},
		--A requirements check to see if the player can pick this quest up, default checks the Delay
		--value, but you can add any logic you want here as you can see the player,quest_npc and quest
		--name are give to you to extract data from to check.
		Requirements =
		{
			Check = function(player,quest_npc,quest)
				if not(CustomQuests.Helpers.CheckDelay(player,quest)) then return false end
				return true
			end,
		},
	},
	--=====================================================================================================
	--end copy above
	
	--=====================================================================================================
	--Global Variable Name for quest
	SlayingThemDamnGoblins =
	{
		--Title of the quest
		Title = "Slaying Them Damn Goblins",
		--Description of the taks the npc wants you to do.
		Description = "Them damn goblins are all around the shrine, can you do something about this please.",
		--The message you get from the npc when you complete the quest
		QuestCompletedMessage = "Thank you very much for your assistance, here is all I have to give you.",
		--The Delay in seconds until the player can pick the quest up again 600 = 10 minutes
		Delay = 600,
		--A list of tasks the player need to complete (MAX 4) due to current UI limitations
		Tasks =
		{  
			CustomQuests.Helpers.AddSlayTask("goblin",4,"slaying_them_damn_goblins","Goblin"),
		},
		--A list of rewards the player earns in their quest bag when completing the quest
		Rewards =
		{
			{Type="coins", MinAmount = 60, MaxAmount = 120,},
			{Type="faction", Faction="Eldeir Village", Value=5, Cap=100},
			--{Type="item", Template="weapon_dagger", Amount=1, Chance=0.5,},
			{Type="magicweapon", Template="weapon_dagger", Rank="RankOne", Chance=0.5},			
		},
		--A requirements check to see if the player can pick this quest up, default checks the Delay
		--value, but you can add any logic you want here as you can see the player,quest_npc and quest
		--name are give to you to extract data from to check.
		Requirements =
		{
			Check = function(player,quest_npc,quest)
				if not(CustomQuests.Helpers.CheckDelay(player,quest)) then return false end
				return true
			end,
		},
	},	
	--=====================================================================================================

}
