-- written by Gizmo
----------------------------------------------------------------------
-- If you like Project Phoenix and want to help support the project
-- you could send any donation amount to jessebutler1975@gmail.com at
-- paypal.com
--
-- Thank you for using my product, 
-- I hope you enjoy it as much as I do
----------------------------------------------------------------------
require 'object_extensions'

local COLOR_VALUE      = "FFFFF0"
local COLOR_VARIABLE   = "5793C5"
local COLOR_NUMBER     = "FF7700"
-----------------------------------------------------------------------
--					   Update Tooltip Information
-----------------------------------------------------------------------
function UpdateToolTip(spawner,isbeingedited)
	local templates = spawner:GetObjVar("templates")
	local min_delay = spawner:GetObjVar("min_delay")
	local max_delay = spawner:GetObjVar("max_delay")
	local min_range = spawner:GetObjVar("min_range")
	local max_range = spawner:GetObjVar("max_range")
	local current_count = spawner:GetObjVar("count_current")
	local count_max = spawner:GetObjVar("count_max")
	local active = spawner:GetObjVar("active")
	local mob_list = spawner:GetObjVar("mob_list")
    local spawner_tag = spawner:GetObjVar("spawner_tag")
    local sleeping = spawner:GetObjVar("Sleeping")
    if(spawner_tag == nil) then spawner_tag="" end


    RemoveTooltipEntry(spawner,"delay")
    SetTooltipEntry(spawner,"delay","[" .. COLOR_VARIABLE .. "]Delay: [" .. COLOR_NUMBER .. "]" .. min_delay .. "[FFFFFF] seconds To [" .. COLOR_NUMBER .. "]" .. max_delay .. "[FFFFFF] seconds",90)

    RemoveTooltipEntry(spawner,"range")
    SetTooltipEntry(spawner,"range","[" .. COLOR_VARIABLE .. "]Range: [" .. COLOR_NUMBER .. "]" .. min_range .. "[FFFFFF] units To [" .. COLOR_NUMBER .. "]" .. max_range .. "[FFFFFF] units", 85)

    if(spawner_tag ~= "") then
        RemoveTooltipEntry(spawner,"spawner_tag")
        SetTooltipEntry(spawner,"spawner_tag","[" .. COLOR_VARIABLE .. "]Spawner Tags: [" .. COLOR_VALUE .. "]"..spawner_tag,80)
    else
        RemoveTooltipEntry(spawner,"spawner_tag")
        SetTooltipEntry(spawner,"spawner_tag","[" .. COLOR_VARIABLE .. "]Spawner Tags: [" .. COLOR_VALUE .. "]".."<none>",80)
    end

    if(active) then
        RemoveTooltipEntry(spawner,"active_status")
        SetTooltipEntry(spawner,"active_status","[00FF00]Online",65)
        RemoveTooltipEntry(spawner,"spawn_status")
        SetTooltipEntry(spawner,"spawn_status","[" .. COLOR_VARIABLE .. "]Status: [" .. COLOR_VALUE .. "]".. "["..current_count.."/"..count_max.."] spawned",70)
    else
        RemoveTooltipEntry(spawner,"active_status")
        SetTooltipEntry(spawner,"active_status","[FF0000]Offline",65)
        RemoveTooltipEntry(spawner,"spawn_status")
        SetTooltipEntry(spawner,"spawn_status","[" .. COLOR_VARIABLE .. "]Status: [" .. COLOR_VALUE .. "]".. "["..current_count.."/"..count_max.."] spawned",70)
    end 

    if(spawner:GetObjVar("sequential")==true) then
        RemoveTooltipEntry(spawner,"spawn_status")
        RemoveTooltipEntry(spawner,"spawner_mode")
        SetTooltipEntry(spawner,"spawner_mode","[" .. COLOR_VARIABLE .. "]Spawn Mode: [" .. COLOR_VALUE .. "]".."Sequential [" .. COLOR_NUMBER .. "](Step by Step)",75)
        SetTooltipEntry(spawner,"current_sequence","[" .. COLOR_VARIABLE .. "]Sequence: [" .. COLOR_VALUE .. "]".. spawner:GetObjVar("current_sequence").."/"..#spawner:GetObjVar("templates"),74)

    else
        RemoveTooltipEntry(spawner,"spawner_mode")
        RemoveTooltipEntry(spawner,"current_sequence")
        SetTooltipEntry(spawner,"spawner_mode","[" .. COLOR_VARIABLE .. "]Spawn Mode: [" .. COLOR_VALUE .. "]Normal [" .. COLOR_NUMBER .. "](Random)",75)       
    end

    RemoveTooltipEntry(spawner,"blank1")
    SetTooltipEntry(spawner,"blank1","   ",69)

    if (spawner:HasObjVar("View.NextTrigTime")) then
        local trigdelay = spawner:GetObjVar("View.NextTrigTime") or (os.time() + spawner:GetObjVar("View.ReTriggerDelay"))
        if(spawner:GetObjVar("View.TriggerActive")) then
            local current_time = os.time()
            local time_left_in_seconds = trigdelay - current_time
            RemoveTooltipEntry(spawner,"NextTrigger")
            SetTooltipEntry("[EEBB00]" .. time_left_in_seconds.."[00FFFF]'s".. "till next retrigger",50)
        end
    end

    if(isbeingedited) then
        RemoveTooltipEntry(spawner,"blank2")
        SetTooltipEntry(spawner,"blank2","   ",2)
        RemoveTooltipEntry(spawner,"is_being_edited")
        SetTooltipEntry(spawner,"is_being_edited","[00FFFF]-Currently Being Edited-",1)
    else
        if(HasTooltipEntry(spawner,"blank2")) then
            RemoveTooltipEntry(spawner,"blank2")
        end
        if(HasTooltipEntry(spawner,"is_being_edited")) then
            RemoveTooltipEntry(spawner,"is_being_edited")
        end
    end

    RemoveTooltipEntry(spawner,"sleeping")
    if(sleeping) then
        current_count = #spawner:GetObjVar("reset_list")
        SetTooltipEntry(spawner,"sleeping","[FF7700][Sleeping]",2)
    else
        SetTooltipEntry(spawner,"sleeping","[22FF22][Awake]",2)
    end

    if(ProjectPhoenix ~= nil) then
        ProjectPhoenix.ApplyTooltip(this)       
    end    
end